<?php

function woowa_safe_variable($k) {
  $k=str_replace(".","_",$k);
  $k=str_replace("-","_",$k);
  $k=str_replace("'","_",$k);
  $k=str_replace("$","_",$k);
  $k=str_replace("@","_",$k);
  $k=str_replace("^","_",$k);
  $k=str_replace("*","_",$k);
  $k=str_replace("%","_",$k);
  $k=str_replace("&","_",$k);
  $k=str_replace("+","_",$k);
  $k=str_replace("=","_",$k);
  $k=str_replace("/","_",$k);
  $k=str_replace(">","_",$k);
  $k=str_replace("<","_",$k);
  $k=str_replace(",","_",$k);
  $k=str_replace(":","_",$k);
  $k=str_replace(";","_",$k);
  return $k;
}

function woowa_url2domain($site_url){
  $site_url=str_replace('https://','',$site_url);
  $site_url=str_replace('http://','',$site_url);
  $site_url=str_replace('www.','',$site_url);
  return $site_url;
}

function woowa_render_view($path_view,$dt){
	ob_start();
	extract($dt);
    include WOOWA_PATH.'modules/'.$path_view;
    return ob_get_clean();
}

function woowa_scripts_styles() {
    if(class_exists('WooPhoneInput_Init')){
    
    }else{
	    wp_register_script('intlTelInput',WOOWA_URI."public/js/intlTelInput.js");
	    wp_enqueue_script('intlTelInput');

	    wp_register_style('intlTelInput',WOOWA_URI."public/css/intlTelInput.css");
	    wp_enqueue_style('intlTelInput');
	}
}

function woowa_inject_head() {
    if(class_exists('WooPhoneInput_Init')){

    }else{
    	$default_country="id";
    	if(get_option('woowa_default_country_code_huruf')!==false and get_option('woowa_default_country_code_huruf')!=''){
    		$default_country=get_option('woowa_default_country_code_huruf');
    	}
    	if($default_country!='br'){
	        echo '<script type="text/javascript">jQuery(function(){
	          jQuery("#billing_phone").attr("type","text");
	          jQuery("#form-field-no_whatsapp").intlTelInput({
	          	preferredCountries: ["'.$default_country.'"],
	          });
	          jQuery("#billing_phone").css("padding-right","40px");
	          jQuery("#billing_phone").intlTelInput({
	          	preferredCountries: ["'.$default_country.'"],
	          });
	        });</script>';
	    }
    }
}

function woowa_hook_wpajax($action){
	add_action( 'wp_ajax_'.$action, 'woowa_'.$action );
	add_action( 'wp_ajax_nopriv_'.$action, 'woowa_'.$action );
}

function woowa_activation_license( $plugin ) {
	if( $plugin == plugin_basename( WOOWA_PATH.'woowa.php' ) ) {
		woowa_activate();
		exit( wp_redirect( admin_url( "admin.php?page=notifierwa-main-menu&tab=license" ) ) );
	}
}

function woowa_activate($from = '') {
	//go live
	$_SESSION['debug']=false;

	//on off toggle multivendor
	add_option('woowa_toggle_wanotif', '');
	add_option('woowa_toggle_apiwha', '');
	add_option('woowa_toggle_waboxapp', '');
	add_option('woowa_toggle_wa_blas', '');
	add_option('woowa_toggle_chat_api', '');
	add_option('woowa_toggle_wassenger', '');
	add_option('woowa_toggle_pesan_enter', '');
	
	// db api dan key pe
	add_option('woowa_ip', '');
	add_option('woowa_api_key', '');
	//aliase init
	add_option('woowa_onhold_alias', 'on-hold');
	add_option('woowa_apk_player_id', '');
	// license type
	add_option('woowa_license_type', '');
	
	//hapus error.log
	// $fp = fopen(WOOWA_PATH.'/modules/error/error.log', 'w');
    // fwrite($fp, "woowa is activated.\n");
    // fclose($fp);

	//hapus dev.log
	$fp = fopen(WOOWA_PATH.'/modules/error/dev.log', 'w');
    fwrite($fp, "");
    fclose($fp);

    //hapus vendor param
    if ( get_option('woowa_default_country_code_huruf') != false ) {
		
	}else{
		add_option('woowa_default_country_code_huruf','id');
	}
    //hapus vendor param
    if ( get_option('woowa_checkbox_customer_note_sendwa') != false ) {
		
	}else{
		add_option('woowa_checkbox_customer_note_sendwa','false');
	}

    //hapus vendor param
    if ( get_option('woowa_vendor_param') != false ) {
		update_option('woowa_vendor_param','');
	}else{
		add_option('woowa_vendor_param','');
	}

	if ( get_option('SENDINGWHA_URL') != false ) {
		// update_option('SENDINGWHA_URL',SENDINGWHA_URL);
	}else{
		add_option('SENDINGWHA_URL',SENDINGWHA_URL);
	}

	if ( get_option('STATISTIC') != false ) {
		// update_option('STATISTIC','');
	}else{
		add_option('STATISTIC',STATISTIC);
	}

	//integrate
	if (get_option("woowa_license_type") == "multivendor") {
		add_option('woowa_toggle_apiwha', '');
		add_option('woowa_toggle_wanotif', '');
		add_option('woowa_toggle_wa_blas', '');
		add_option('woowa_toggle_chat_api', '');
		add_option('woowa_toggle_waboxapp', '');
		add_option('woowa_toggle_wassenger', '');
	}

    //seller notif after checkout
    if ( get_option('woowa_check_after_checkout') != false ) {
		update_option('woowa_check_after_checkout','checked=checked');
	}else{
		add_option('woowa_check_after_checkout','checked=checked');
	}

    //hapus vendor param
    if ( get_option('woowa_vendor_temp') != false ) {
		update_option('woowa_vendor_temp','');
	}else{
		add_option('woowa_vendor_temp','');
	}

    //hapus vendor param
    if ( get_option('woowa_custom_form_scan_url') != false ) {
		update_option('woowa_custom_form_scan_url','');
	}else{
		add_option('woowa_custom_form_scan_url','');
	}

    //hapus vendor param
    if ( get_option('woowa_custom_form_scan_url_response') != false ) {
		update_option('woowa_custom_form_scan_url_response','');
	}else{
		add_option('woowa_custom_form_scan_url_response','');
	}

	if ($from == 'update') {
		# code...
	}else {
		//hapus license
		if ( get_option('woowa_license') != false ) {
			update_option("woowa_license",'deactive');
		}else{
			add_option('woowa_license','deactive');
		}
		if ( get_option('woowa_license_number') != false ) {
			update_option("woowa_license_number",'');
		}else{
			add_option('woowa_license_number','');
		}
	}

	if ( get_option('woowa_checkbox_wa_text') == false ) {
	    add_option('woowa_checkbox_wa_text','Send me order detail notification through Whatsapp');
	}
	if ( get_option('woowa_checkbox_wa_notif') == false ) {
	    add_option('woowa_checkbox_wa_notif', "");
	}else{
		update_option('woowa_checkbox_wa_notif', "");
	}

	
	$pesan="Hi {billing_first_name}, Thank you for your order at {site_url} at {order_date_created} .
This is your detail order:
 *First Name* : {billing_first_name}
 *Address* : {billing_address_1}
 *City* : {billing_city}
 *Post Code* : {billing_postcode}
 *State* : {billing_state}
 *Whatsapp number* : {billing_phone}
 *Product* : {product_name}
 *Total Amount* : {total_amount}

Please finish your payment with {payment_method_title}

Transfer the money to:
-Bank: Woowa Bank
-Account Name: John Doe
-Account Number: 987654321

If you have any questions, please contact {site_url}
Thank you so much.
	";
	if ( get_option('woowa_pesan_after_checkout') == false ) {
	    add_option('woowa_pesan_after_checkout',$pesan);
	}else {
		//update_option('woowa_pesan',$pesan);
	}

$pesan="Hi {billing_first_name}, Thank you for your order at {site_url} at {order_date_created} .
This is your detail order:
 *First Name* : {billing_first_name}
 *Address* : {billing_address_1}
 *City* : {billing_city}
 *Post Code* : {billing_postcode}
 *State* : {billing_state}
 *Whatsapp number* : {billing_phone}
 *Product* : {product_name}
 *Total Amount* : {total_amount}

Please finish your payment with {payment_method_title}

Transfer the money to:
-Bank: Woowa Bank
-Account Name: John Doe
-Account Number: 987654321

If you have any questions, please contact {site_url}
Thank you so much.
	";
	if ( get_option('woowa_pesan_custom_status') == false ) {
	    add_option('woowa_pesan_custom_status',$pesan);
	}else {
		//update_option('woowa_pesan',$pesan);
	}
	
	$pesan="Halooo {form_fields[nama]}, this is how Woowa for Caldera form works !

Get all information what you filled before:
name : {form_fields[name]}
phone : {form_fields[no-wa]}
your message : {form_fields[message]}

Awesoommee ! :heart_eyes:";
	if ( get_option('woowa_pesan_custom_form') == false ) {
	    add_option('woowa_pesan_custom_form',$pesan);
	}else {
		//update_option('woowa_pesan',$pesan);
	}

	$pesan="Huurraaaaayyy ! Your Order is Completed ! 🌟

Hi {billing_first_name}, Thank you for your order at {site_url} at {order_date_created} .
This is your detail order:
 *First Name* : {billing_first_name}
 *Address* : {billing_address_1}
 *City* : {billing_city}
 *Post Code* : {billing_postcode}
 *State* : {billing_state}
 *Whatsapp number* : {billing_phone}
 *Product* : {product_name}
 *Total Amount* : {total_amount}

We hope you really enjoy our product 😍
If you have any questions, please contact {site_url}

Thank you so much. ☺🙏🙏	    
	";
	if (get_option('woowa_pesan_order_complete')== false) {
    	add_option( 'woowa_pesan_order_complete', $pesan);
	}else {
		//update_option( 'woowa_pesan_order_complete', $pesan);
	}

	$pesan="This is after sales message!
Don't forget to keep in touch with us! and dont miss our great deal!!

We hope you really enjoy our product 😍
If you have any questions, please contact {site_url}

Thank you so much. ☺🙏🙏	    
	";
	if (get_option('woowa_pesan_order_complete_followup')== false) {
    	add_option( 'woowa_pesan_order_complete_followup', $pesan);
	}else {
		//update_option( 'woowa_pesan_order_complete', $pesan);
	}
	
	$pesan="Wooah!!?? ! Your Order is Canceled ! 🌟

Hi {billing_first_name}, I am sorry. For your order at {site_url} at {order_date_created} .
This is your detail order:
 *First Name* : {billing_first_name}
 *Address* : {billing_address_1}
 *City* : {billing_city}
 *Post Code* : {billing_postcode}
 *State* : {billing_state}
 *Whatsapp number* : {billing_phone}
 *Product* : {product_name}
 *Total Amount* : {total_amount}

We apologize, but your order has been canceled.
if you want to ask further questions please contact the admin

Thank you so much. ☺🙏🙏	    
	";
	if (get_option('woowa_pesan_cancel_order')== false) {
    	add_option( 'woowa_pesan_cancel_order', $pesan);
	}

	$pesan="Wuhuuu it is our lucky day!!

Hi Boss!, somebody just bought item on our {site_url} website! at {order_date_created} .

This is your detail order:
*First Name* : {billing_first_name}
*Address* : {billing_address_1}
*City* : {billing_city}
*Post Code* : {billing_postcode}
*State* : {billing_state}
*Whatsapp number* : {billing_phone}
*Product* : {product_name}
*Total Amount* : {total_amount}

follow up them by click this: wa.me/62{billing_phone}

Lets keep our hardwork!!";
		if (get_option('woowa_pesan_seller_notification')== false) {
			add_option( 'woowa_pesan_seller_notification', $pesan);
		}else {
			//update_option( 'woowa_pesan_order_complete', $pesan);
		}

	$pesan="DEFAULT
Hi {billing_first_name}, In case you forgot, we would like to remind you about your order at {site_url} in {order_date_created} .

This is your detail order:
*Order Id* : {order_id}
*First Name* : {billing_first_name}
*Address* : {billing_address_1}
*City* : {billing_city}
*Post Code* : {billing_postcode}
*State* : {billing_state}
*Whatsapp number* : {billing_phone}
*Product* : {product_name}
*Total Amount* : {total_amount}

Please finish your payment with {payment_method_title} at least *24 hours* from now or your order will be cancelled.

Transfer the money to:
-Bank: Woowa Bank
-Account Name: John Doe
-Account Number: 987654321

If you have any questions, please contact {site_url}
Thank you so much.";
	if (get_option('woowa_pesan_reminder_order')== false) {
    	add_option( 'woowa_pesan_reminder_order', $pesan);
		add_option( 'woowa_pesan_reminder_order_gambar', '');
		add_option('woowa_check_reminder_order', '');
    }else{
		//update_option( 'woowa_pesan_reminder_order', $pesan);
	}

	$pesan="TEMPLATE 1
Im sorry to remind you again {billing_first_name}, your order at {site_url} in {order_date_created} not yet been paid,

This is your detail order:
*Order Id* : {order_id}
*First Name* : {billing_first_name}
*Address* : {billing_address_1}
*City* : {billing_city}
*Post Code* : {billing_postcode}
*State* : {billing_state}
*Whatsapp number* : {billing_phone}
*Product* : {product_name}
*Total Amount* : {total_amount}

Please finish your payment with {payment_method_title}, we will remind you again later

Transfer the money to:
-Bank: Woowa Bank
-Account Name: John Doe
-Account Number: 987654321

If you have any questions, please contact {site_url}
Thank you so much.";
	if (get_option('woowa_pesan_reminder_order1')== false) {
		add_option( 'woowa_pesan_reminder_order1', $pesan);
		add_option( 'woowa_pesan_reminder_order_gambar1', '');
		add_option('woowa_check_reminder_order1', '');
    }else{
		//update_option( 'woowa_pesan_reminder_order', $pesan);
	}

	$pesan="TEMPLATE 2
Come on {billing_first_name}, our stock are running out !

Your order at {order_date_created} not yet been paid

This is your detail order:
*Order Id* : {order_id}
*First Name* : {billing_first_name}
*Address* : {billing_address_1}
*City* : {billing_city}
*Post Code* : {billing_postcode}
*State* : {billing_state}
*Whatsapp number* : {billing_phone}
*Product* : {product_name}
*Total Amount* : {total_amount}

Please finish your payment with {payment_method_title}, we will remind you again later

Transfer the money to:
-Bank: Woowa Bank
-Account Name: John Doe
-Account Number: 987654321

If you have any questions, please contact {site_url}
Thank you so much.";
	if (get_option('woowa_pesan_reminder_order2')== false) {
		add_option( 'woowa_pesan_reminder_order2', $pesan);
		add_option( 'woowa_pesan_reminder_order_gambar2', '');
		add_option('woowa_check_reminder_order2', '');
    }else{
		// update_option( 'woowa_pesan_reminder_order', $pesan);
	}

	$pesan="TEMPLATE 3

Oh im afraid you gonna lose you this rare Opportunity {billing_first_name}, your Coupon code will expired in 6 hours !

This is your detail order:
*Order Id* : {order_id}
*First Name* : {billing_first_name}
*Address* : {billing_address_1}
*City* : {billing_city}
*Post Code* : {billing_postcode}
*State* : {billing_state}
*Whatsapp number* : {billing_phone}
*Product* : {product_name}
*Total Amount* : {total_amount}

Please finish your payment with {payment_method_title},

or Transfer directly to:
-Bank: Woowa Bank
-Account Name: John Doe
-Account Number: 987654321

If you have any questions, please contact {site_url}
Thank you so much.

*THIS IS YOUR LAST CHANCE*";
	if (get_option('woowa_pesan_reminder_order3')== false) {
		add_option( 'woowa_pesan_reminder_order3', $pesan);
		add_option( 'woowa_pesan_reminder_order_gambar3', '');		
		add_option('woowa_check_reminder_order3', '');
    }else{
		
	}

	$pesan=" 
We are so sorry
but we your order.
This is your detail order:
*Order Id* : {order_id}
*First Name* : {billing_first_name}
*Address* : {billing_address_1}
*City* : {billing_city}
*Post Code* : {billing_postcode}
*State* : {billing_state}
*Whatsapp number* : {billing_phone}
*Product* : {product_name}
*Total Amount* : {total_amount}

will be refund! if you need more information please tell us!
thank you!
	
	";
	if (get_option('woowa_pesan_order_refund')== false) {
		add_option( 'woowa_pesan_order_refund', $pesan);
    }else{
		
	}

	$pesan="
Hello there! we just want to tell you.
your order at {site_url} with these details:
{order_date_created} .
This is your detail order:
*First Name* : {billing_first_name}
*Address* : {billing_address_1}
*City* : {billing_city}
*Post Code* : {billing_postcode}
*State* : {billing_state}
*Whatsapp number* : {billing_phone}
*Product* : {product_name}
*Total Amount* : {total_amount}

your order now is on process!! wait and you will love our product!!!
	
	";
	if (get_option('woowa_pesan_order_process')== false) {
		add_option( 'woowa_pesan_order_process', $pesan);
    }else{
		
	}
	
	$pesan=
"Hey! {billing_first_name}
We notice something wrong with your order at {site_url}
and your order with this detail

*Order Id* : {order_id}
*First Name* : {billing_first_name}
*Address* : {billing_address_1}
*City* : {billing_city}
*Post Code* : {billing_postcode}
*State* : {billing_state}
*Whatsapp number* : {billing_phone}
*Product* : {product_name}
*Total Amount* : {total_amount}

is failed to process, please re-order at {site_url}
or contact our costumer sevice!
thanks!";
	if (get_option('woowa_pesan_order_failed')== false) {
		add_option( 'woowa_pesan_order_failed', $pesan);
    }else{
		
	}
	
	$pesan=
"Hey {billing_first_name}
Look like you forget to do something!
do you remember you buy some great item at {site_url}
this is your order details!

*Order Id* : {order_id}
*First Name* : {billing_first_name}
*Address* : {billing_address_1}
*City* : {billing_city}
*Post Code* : {billing_postcode}
*State* : {billing_state}
*Whatsapp number* : {billing_phone}
*Product* : {product_name}
*Total Amount* : {total_amount}

and its time to pay and you will get your order as soon as possible!!
thanks!";
	if (get_option('woowa_pesan_pending_payment') == false) {
		add_option( 'woowa_pesan_pending_payment', $pesan);
    }
}

/**
 * Debug function
 * @since 1.0.0
 * @return array
 */
if ( ! function_exists( 'woowa_debug' ) ) :

    function woowa_debug()
    {
        $bt     = debug_backtrace();
		$caller = array_shift($bt); ?>
        <pre class='woowa_debug'><?php
		print_r([
			"file"  => $caller["file"],
			"line"  => $caller["line"],
			"args"  => func_get_args()
		]); ?>
        </pre>
        <?php
    }

endif;