<?php

function woowa_table_abandoned_cart(){
    $popup = woowa_popup_abandoned_cart();

    if (get_option('woowa_license') != 'active') {
        return '<br>please activate license code. click <a href="'.site_url().'/wp-admin/admin.php?page=notifierwa-settings"  aria-expanded="true">here</a>';
    }

    $data = array_reverse(woowa_get_abandoned_cart());
    $view = '
    <h3 style="display: inline-block;">Abandoned Cart List</h3>&nbsp <button type="button" class="btn btn-xs btn-primary" data-target="#tooltipabandonedcart" style="margin-bottom:13px" data-toggle="modal"><i class="fas fa-question"></i></button>';

    $view .='
    <table class="table">
        <thead>
            <tr>
                <th scope="col">No</th>
                <th scope="col"><input type="checkbox" id="checkAllaban"></th>
                <th scope="col">Name</th>
                <th scope="col">Phone</th>
                <th scope="col">Product Name</th>
                <th scope="col">Time</th>
                <th scope="col">Last Sent</th>
                <th scope="col">Action <button class="btn btn-success btn-xs bulk-abandoned" onclick="return ajax_bulk_abandoned()">Bulk Send WA</button><span id=""></span></th>
            </tr>
        </thead>
        <tbody>';
        foreach ($data as $key => $value) {
            $cart_contents = unserialize($value['cart_contents']);
            $products = Array();

            if(!empty($cart_contents)){
                foreach ($cart_contents as $k => $v) {
                    $products[] = $v['product_title'].' ('. $v['quantity'].')';
                }
            }

            $last_sent = '-';
            if (!empty(get_post_meta('00000'.$value['id'], 'woowa_ac_last_send', true))) {
                $last_sent = get_post_meta('00000'.$value['id'], 'woowa_ac_last_send', true);
            }

            $product_name =  implode(', ',$products);
            $view .='
                <tr class="tabelel">
                    <th scope="row">'.($key+1).'</th>
                    <td><input type="checkbox" class="check_abandoned"></td>
                    <td>'.$value['name'].'</td>
                    <td>'.$value['phone'].'</td>
                    <td>'.$product_name.'</td>
                    <td>'.$value['time'].'</td>
                    <td id="last_sent_ac'.$value['id'].'">'.$last_sent.'</td>
                    <td class="abandoned_table"><a type="button" class="btn btn-success abandoned"  onclick="return ajax_send_wa_abandoned(\''.$value['id'].'\')">Send WA</a><span class="woowa-span" id="woowa-span'.$value['id'].'"></span></td>
                </tr>';
        }
        $view .= '
        </tbody>
    </table>';

    return $view.$popup;
}

function woowa_popup_abandoned_cart(){
    $view = 
    '<div class="modal fade" id="tooltipabandonedcart" tabindex="-1" role="dialog" aria-labelledby="tooltipabandonedcartLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="tooltipabandonedcartLabel">You need to install those plugin to enjoy the features</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <img src="'.site_url().'/wp-content/plugins/woowa/public/img/how-to-get-abbandoned-plugin.jpg" style="display: block; margin-left: auto; margin-right: auto; width: 50%;">
                </div>
                <div div class="modal-body">
                    <a type="button" class="btn btn-success" data-dismiss="modal" onclick="window.open(\'https://wordpress.org/plugins/woo-save-abandoned-carts/\',\'_blank\')">Click here to get your abandoned cart plugin</a>
                </div>
            </div>
        </div>
    </div>';
 
    return $view;
}