<?php

function woowa_wassenger_view($provider){
    $woowa_wassenger_token = get_option('woowa_provider_token'.$provider);
    $view = '
    <form id="integrate_wassenger">
        <input type="hidden" name="action" value="save_data_api" >
        <div class="form-group">
            <label for="wassenger_token">Token Wassenger</label>
            <input type="text" class="form-control" id="wassenger_token" value="'.$woowa_wassenger_token.'" name="wassenger_token" aria-describedby="token-wassenger" placeholder="Enter Wassenger Token">
            <small id="token-wassenger" class="form-text text-muted">ex: asdasdadawd1235asdqe</small>
        </div>
        <p><a target="_blank" href="https://wassenger.com"> Wassenger Website</a></p>
        <button class="btn btn-success" onclick="return ajax_save_data_api(\'wassenger\')" name="integrate_wassenger">Save</button>
        <div id="notif_wassenger"></div>
    </form>

    ';

    return $view;
}

function woowa_chat_api_view($provider){
    $woowa_url_chat_api = get_option('woowa_url_provider'.$provider); 
    $woowa_chat_api_token = get_option('woowa_provider_token'.$provider);
    $view = '
    <form id="integrate_chat_api">
        <input type="hidden" name="action" value="save_data_api" >
        <div class="form-group">
            <label for="chat_api_token">Token Chat Api</label>
            <input type="text" class="form-control" id="chat_api_token" value="'.$woowa_chat_api_token.'" name="chat_api_token" aria-describedby="token-chat-api" placeholder="Enter Chat Api Token">
            <small id="token-chat-api" class="form-text text-muted">ex: asdasdadawd1235asdqe</small>
        </div>
        <div class="form-group">
            <label for="url-chat-api">URL</label>
            <input type="url-chat-api" class="form-control" id="url-chat-api" value="'.$woowa_url_chat_api.'" name="url_chat_api" placeholder="Enter chat URL">
        </div>
        <p><a target="_blank" href="https://chat-api.com">Chat Api Website</a></p>
        <button class="btn btn-success" onclick="return ajax_save_data_api(\'chat_api\')" name="integrate_chat_api">Save</button>
        <div id="notif_chat_api"></div>
    </form>

    ';

    return $view;
}

function woowa_wa_blas_view($provider){
    $woowa_wa_blas_token = get_option('woowa_provider_token'.$provider);
    // $woowa_wa_blas_device = get_option('woowa_provider_device'.$provider);
    $view = '
    <form id="integrate_wa_blas">
        <input type="hidden" name="action" value="save_data_api" >
        <div class="form-group">
            <label for="wa_blas_token">Token Wablas</label>
            <input type="text" class="form-control" id="wa_blas_token" value="'.$woowa_wa_blas_token.'" name="wa_blas_token" aria-describedby="token-wa-blas" placeholder="Enter Wablas Token">
            <small id="token-wablas" class="form-text text-muted">ex: asdasdadawd1235asdqe</small><br>
            <small id="wablas-documentation" class="form-text text-muted"><a href="https://wablas.com/" target=”_blank”>Wablas Website</a></small>
        </div>
        <button class="btn btn-success" onclick="return ajax_save_data_api(\'wa_blas\')" name="integrate_wa_blas">Save</button>
        <div id="notif_wa_blas"></div>
    </form>

    ';

    return $view;
}

function woowa_apiwha_view($provider){
    $woowa_apiwha_token = get_option('woowa_provider_token'.$provider);
    // $woowa_apiwha_device = get_option('woowa_provider_device'.$provider);
    $view = '
    <form id="integrate_apiwha">
        <input type="hidden" name="action" value="save_data_api" >
        <div class="form-group">
            <label for="apiwha_token">Api-Key</label>
            <input type="text" class="form-control" id="apiwha_token" value="'.$woowa_apiwha_token.'" name="apiwha_token" aria-describedby="token-chat-api" placeholder="Enter Apikey from Apiwha">
            <small id="token-wablas" class="form-text text-muted">ex: asdasdadawd1235asdqe</small><br>
            <small id="apiwha-documentation" class="form-text text-muted"><a href="https://apiwha.com" target=”_blank”>Apiwha Website</a></small>
        </div>
        <button class="btn btn-success" onclick="return ajax_save_data_api(\'apiwha\')" name="integrate_apiwha">Save</button>
        <div id="notif_apiwha"></div>
    </form>

    ';

    return $view;
}

function woowa_waboxapp_view($provider){
    $woowa_waboxapp_token = get_option('woowa_provider_token'.$provider);
    $woowa_waboxapp_device = get_option('woowa_provider_device'.$provider);
    // $woowa_waboxapp_device = get_option('woowa_provider_device'.$provider);
    $view = '
    <form id="integrate_waboxapp">
        <input type="hidden" name="action" value="save_data_api" >
        <div class="form-group">
            <label for="waboxapp_token">Api-Key</label>
            <input type="text" class="form-control" id="waboxapp_token" value="'.$woowa_waboxapp_token.'" name="waboxapp_token" aria-describedby="token-chat-api" placeholder="Enter Apikey from waboxapp">
            <small id="token-wablas" class="form-text text-muted">ex: asdasdadawd1235asdqe</small><br><br>
            <label for="waboxapp_token">Number Whatsapp Sender</label>
            <input type="text" class="form-control" id="waboxapp_device" value="'.$woowa_waboxapp_device.'" name="waboxapp_device" aria-describedby="device-chat-api" placeholder="Enter your number from waboxapp">
            <small id="device-wablas" class="form-text text-muted">ex: 628190273112</small><br>
            <small id="waboxapp-documentation" class="form-text text-muted"><a href="https://www.waboxapp.com/" target=”_blank”>Waboxapp Website</a></small>
        </div>
        <button class="btn btn-success" onclick="return ajax_save_data_api(\'waboxapp\')" name="integrate_waboxapp">Save</button>
        <div id="notif_waboxapp"></div>
    </form>

    ';

    return $view;
}

function woowa_wanotif_view($provider){
    $woowa_wanotif_token = get_option('woowa_provider_token'.$provider);
    // $woowa_wanotif_device = get_option('woowa_provider_device'.$provider);
    $view = '
    <form id="integrate_wanotif">
        <input type="hidden" name="action" value="save_data_api" >
        <div class="form-group">
            <label for="wanotif_token">Api-Key</label>
            <input type="text" class="form-control" id="wanotif_token" value="'.$woowa_wanotif_token.'" name="wanotif_token" aria-describedby="token-chat-api" placeholder="Enter Apikey from Wanotif">
            <small id="token-wablas" class="form-text text-muted">ex: lRKq4bQf1H9UaFTGCiXcBzu</small><br>
            <p><a href="https://wanotif.id" target=”_blank”>Wanotif Website</a></p>
        </div>
        <button class="btn btn-success" onclick="return ajax_save_data_api(\'wanotif\')" name="integrate_wanotif">Save</button>
        <div id="notif_wanotif"></div>
    </form>

    ';

    return $view;
}
