<?php

$ip = get_option('woowa_ip');
$key = get_option('woowa_api_key');

if (get_option('woowa_license') == 'active' && get_option('woowa_license_type') != 'android' && get_option('woowa_license_type') != 'multivendor') {
   if (empty($ip or $key)) {
      add_action( 'admin_notices', 'woowa_error_key_api' );
   }
}

function woowa_error_key_api() {
	$class = 'notice notice-error';
	$message = __( 'Woowa Notice : Please insert your IP and Key ! <a href="'.site_url().'/wp-admin/admin.php?page=notifierwa-main-menu&tab=license">Here</a>', site_url() );

	printf( '<div style="margin-left: 0px;" class="%1$s"><p>%2$s</p></div>', esc_attr( $class ),  $message  ); 
}

function woowa_license_view(){
   $script = woowa_script_license_notif();

   if( isset( $_POST['submit'] ) && sanitize_text_field ( $_POST['action'] ) == "activate" ){ 
      $res=woowa_activate_license_callback($_POST); 
   }elseif( isset( $_POST['submit'] ) && sanitize_text_field ( $_POST['action'] ) == "deactivate" ){
      $res=woowa_deactivate_license_callback(); 
   } 

   $status_license=get_option("woowa_license");
   if (empty($status_license)) {
      add_option("woowa_license","",null,'no');
   }

   if (empty(get_option("woowa_license_number"))) {
      add_option("woowa_license_number","",null,'no');
   }

   if (isset( $_POST['submit'] )) {
      header("location:".site_url()."/wp-admin/admin.php?page=notifierwa-main-menu&tab=license&n=$res");
      wp_die();
   }

   if (empty($status_license) or $status_license=='deactive') {
      $form='<input id="my-license" type="text" name="my-license" value="" required="required"> 
      <input type="hidden" name="action" value="activate">
      <input type="submit" name="submit" value="Activate" class="btn btn-success"> ';
   }else{
      $form='<input id="my-license" type="hidden" name="my-license" value="'.get_option('woowa_license_number').'" required="required"> 
      <input type="hidden" name="action" value="deactivate"> 
      <input type="submit" name="submit" value="Deactivate" class="btn btn-danger"> ';
   }

   $n='';
   if (isset($_GET['n'])) {
      $n.=$_GET['n']."<br>";
   }

   $tgl_expired = woowa_cek_license_expired();
   if ( get_option('woowa_license_number') !== false and get_option('woowa_license_number')!='') {
      if ( get_option('woowa_license_number') !== false and get_option('woowa_license_number')!='') {
         if ($tgl_expired == ("0000-00-00") or $tgl_expired == '') {
            $n = '';
         }else {
            $n.='License will expired at <b>'.date('F,d Y',strtotime($tgl_expired));
         }
      }
   }
   $ip = get_option('woowa_ip');
   $key = get_option('woowa_api_key');
   $license = get_option('woowa_license_number');
   $ip_used = '';
   $key_used = '';

   //$form_ip = '<br><span>IP </span><br><input id="my-ip" type="text" name="my-ip" value="" placeholder="IP Here">';
   $form_ip = '';
   $form_key = '<br><span>Key </span><br><input id="my-key" type="text" name="my-key" value="" placeholder="Key Here"> <br><br>
   <p>Where can i find my IP and Key?<br> Go <a href="https://app.woo-wa.com/dashboard/" target="_blank">Here</a> > More > Get IP & Key</p>
   <br><button class="btn btn-success btn-sm" onclick="return get_ip_key();" name="save_ip_key">Save</button>';

   (empty($license)) ? $license_used = '' : $license_used = '<br><span>License </span><br>********'.substr($license, -5, 5);
   if (get_option('woowa_license') == 'active' && get_option('woowa_license_type') != 'android' && get_option('woowa_license_type') != 'multivendor') {
      (empty($ip)) ? $ip_used = $form_ip : $ip_used = '<br><span>IP <br> ********'.substr($ip, -8, 8);
      (empty($key)) ? $key_used = $form_key : $key_used = '<br><span>Key <br>********'.substr($key, -8, 8);
      
   }
   
   $html= '<h1 class="wp-heading-inline" style="display: inline-block;">Woowa License</h1> <button type="button" class="btn btn-xs btn-primary" data-target="#tooltiplicense" style="margin-bottom:13px" data-toggle="modal"><i class="fas fa-question"></i></button>
   <form method="post"> 
      <label for="my-license">License</label> 
      '.$form.'
   </form>
   <form method="post">
      <br> '.$n.'</b><br>
      '.$license_used.'
      '.$ip_used.'
      '.$key_used.'
   </form> ';

   $popup = woowa_popup_license();
   
   return $html.$script.$popup;
}

function woowa_popup_license(){
   $view = 
   '<div class="modal fade" id="tooltiplicense" tabindex="-1" role="dialog" aria-labelledby="tooltiplicenseLabel" aria-hidden="true">
     <div class="modal-dialog modal-lg" role="document">
       <div class="modal-content">
         <div class="modal-header">
           <h5 class="modal-title" id="tooltiplicenseLabel">Where is your license? Here!</h5>
           <button type="button" class="close" data-dismiss="modal" aria-label="Close">
             <span aria-hidden="true">&times;</span>
           </button>
         </div>
         <div class="modal-body">
           <img src="'.site_url().'/wp-content/plugins/woowa/public/img/how-to-get-license.jpg" style="display: block; margin-left: auto; margin-right: auto; width: 50%;">
         </div>
         <div class="modal-body">
           <a type="button" class="btn btn-success" data-dismiss="modal" onclick="window.open(\'https://app.woo-wa.com\',\'_blank\')">Click here to get your license</a>
         </div>
       </div>
     </div>
   </div>';

   return $view;
}