<?php

function woowa_remove_metadata($protected, $meta_key) {
    if ( in_array( $meta_key, array( 'cs_rotator', 'bulk_template', 'kirim_wa_ke', 'kirim_wa', 'reminder_time_terakhir', 'terakhir_kirim_wa', 'woowa_apk_order', 'follow_up', 'follow_up_send', 'woowa_meta_box_slug' ) ) ) {
        return true;
    }

    return $protected;
}

function woowa_customer_note($dt){

    $sendwa = get_option('sendwa');

	if (get_option('woowa_checkbox_customer_note_sendwa') == false) {
        return false;
    }
    
    $data_api['text'] = $dt['customer_note'];
    $data_api['license'] = get_option('woowa_license_number');
    $site_url = get_site_url();
    $site_url = str_replace('https://', '', $site_url);
    $site_url = str_replace('http://', '', $site_url);
    $site_url = str_replace('www.', '', $site_url);
    $site_url_arr = explode('/', $site_url);

    if (is_array($site_url_arr)) {
        $site_url = $site_url_arr[0];
    }

    $data_api['domain'] = $site_url;
    $data_api['tipe'] = 'customer_note';
    $order_id = $dt['order_id'];
    $order = wc_get_order($order_id);

    $postmetas = get_post_meta($order_id);

    foreach($postmetas as $meta_key=>$meta_value) {
        $$meta_key = $meta_value[0];
    }

    $billing_phone = $order->get_billing_phone();
    $billing_country = $order->get_billing_country();

    $no_wa_tujuan = woowa_validasi_nomor($billing_phone, $billing_country);
    
    $data_api['no_wa_tujuan'] = $no_wa_tujuan;

    (get_post_meta($order_id, 'cs_rotator', true)) ? update_post_meta($order_id, 'cs_rotator', 'belum') : add_post_meta($order_id, 'cs_rotator', 'belum');

    if(get_option('woowa_license_type') == 'android'){
        if(get_option("woowa_toggle_cs_rotator") != '') {
            $kirim='ok';
        }
    
        if ($kirim=='ok') {
            $datacs = get_option('woowa_customer_service_data');
            $dt_cs = json_decode($datacs,1);
            $jmlh = count($dt_cs);
    
            if ( get_option('woowa_current_cs_rotator') != true ) { add_option('woowa_current_cs_rotator',1);}
    
            if (get_option('woowa_current_cs_rotator') > $jmlh) {
                update_option('woowa_current_cs_rotator', 1);
                woowa_writelog('List CS now start from 1');
            }
    
            $dt_cs = array_values($dt_cs);
            foreach ($dt_cs as $k_cs => $v_cs){
                $current_cs_rotator=get_option('woowa_current_cs_rotator');
                $cs_id = $k_cs+1;
                $wa_cs = $no_wa_tujuan;
                $player_id = $v_cs['player_id'];
    
                if ($current_cs_rotator == $cs_id) {
                    if (!empty(get_option('woowa_toggle_customer_service'.$current_cs_rotator))){
                        if (get_post_meta($order_id, 'cs_rotator', true) == 'belum' ) {
                            woowa_send_api_cs($data_api, $order_id, $data_api['text'], $billing_country, $wa_cs, $player_id, $v_cs['name']);
                            $next_cs_rotator = $current_cs_rotator+1;
                            update_option('woowa_current_cs_rotator', $next_cs_rotator);
                            if (get_post_meta($order_id, 'woowa_apk_order', TRUE) == 'kosong') {
                            }
                            update_post_meta($order_id, 'woowa_apk_order', $player_id);
                            update_post_meta($order_id, 'cs_rotator', 'sudah');
                        }
                    }else {
                        $next_cs_rotator = $current_cs_rotator+1;
                        update_option('woowa_current_cs_rotator', $next_cs_rotator);
    
                        if ($next_cs_rotator > $jmlh) {
                            update_option('woowa_current_cs_rotator', 1);
                            $next_cs_rotator = get_option('woowa_current_cs_rotator');
    
                            if ($next_cs_rotator == $cs_id){
                                if (!empty(get_option('woowa_toggle_customer_service'.$next_cs_rotator))) {
                                    if (get_post_meta($order_id, 'cs_rotator', true) == 'belum' ) {
                                        woowa_send_api_cs($data_api, $order_id, $data_api['text'], $billing_country, $wa_cs, $player_id, $v_cs['name']);
    
                                        $last_cs_rotator = $next_cs_rotator+1;
                                        update_option('woowa_current_cs_rotator', $last_cs_rotator);
                                        if (get_post_meta($order_id, 'woowa_apk_order', TRUE) == 'kosong') {
                                        }
                                        update_post_meta($order_id, 'cs_rotator', 'sudah');
                                        update_post_meta($order_id, 'woowa_apk_order', $player_id);
                                    }
                                }else {
                                    $last_cs_rotator = $next_cs_rotator+1;
                                    update_option('woowa_current_cs_rotator', $last_cs_rotator);
                                }
                            }
                        }
                    }
                }
            }
        }
    }else {
        woowa_curl_post($data_api, $order_id);
    }
}

function woowa_file_upload(){
    $namafile = $_FILES['file']['name'];
    $upload = wp_upload_bits($namafile, null, file_get_contents($_FILES['file']['tmp_name']));
    $dir = wp_upload_dir();
    $urlgambar = $dir['url']."/$namafile";
    wp_die($urlgambar);
}

function woowa_form($order_id, $tipe){
    $order = wc_get_order($order_id);
    foreach ($order->get_items() as $item_key => $item_values):
        $item_id           = $item_values->get_id();
        $item_name         = $item_values->get_name();
        $item_data         = $item_values->get_data();
        $item_type         = $item_values->get_type();
        $product           = $item_values->get_product();
        $product_id        = $item_values->get_product_id();
        $product_link      = get_permalink($product_id);
        $product_links[]   = get_permalink($product_id);

        $line_total             = $item_data['total'];
        $quantity               = $item_data['quantity'];
        $line_subtotal          = $item_data['subtotal'];
        $line_total_tax         = $item_data['total_tax'];
        $tax_class              = $item_data['tax_class'];
        $product_id             = $item_data['product_id'];
        $line_subtotal_tax      = $item_data['subtotal_tax'];
        $variation_id           = $item_data['variation_id'];
        $Arrproduct_name[]      = $item_data['name'].' x '.$quantity;
        $Arrproduct_name_link[] = $item_data['name'].' x '.$quantity."\n".$product_link;
    endforeach;
    
    $ast_no_resi          = get_post_meta($order_id , '_wc_shipment_tracking_items', true )[0]['tracking_number'];
    // $ast_link_tracking    = 'https://resi.id/s/'.$ast_no_resi;

    $postmetas = get_post_meta($order_id);

    foreach($postmetas as $meta_key=>$meta_value) {
        $$meta_key = $meta_value[0];
    }

    
    $shipping = $order->get_items( 'shipping' );
    $resi     = get_post_meta($order_id , '_indo_ongkir_resi', true );

    $array_recipt = [];
    $array_recipt_after = [];

    foreach ($shipping as $item_id => $item) {
        $item_resi = isset( $resi[$item_id] ) ? $resi[$item_id] : '';
        $x = $item->get_name();
        $y = $item_resi;
        $z = $item->get_total();

        $meta_items1 = $item->get_meta( 'Items' );
        $meta_items = str_replace("&times;", "x", $meta_items1);
        if ($meta_items == '' || empty($meta_items)) {
            $meta_items = $product_name;
        }

        $array_recipt_after[] = "Produk : ".$meta_items."\r\nExpedisi : ".$x."\r\nTarif Ongkir : ".$z;
        $array_recipt[] = "Produk : ".$meta_items."\r\nExpedisi : ".$x."\r\nTarif Ongkir : ".$z."\r\nNo. Resi : ".$y;
    }

    $woowa_additional_info = get_post_meta( $order_id, 'woowa_meta_box_slug', true );
    $indo_ongkir_resi = implode("\r\n\r\n", $array_recipt);
    $indo_ongkir = implode("\r\n\r\n", $array_recipt_after);

    if (!empty($Arrproduct_name_link)) {
        $product_name_link = implode("\n", $Arrproduct_name_link);
    } else {
        $product_name_link = '';
    }
    
    if (!empty($product_links)) {
        $product_link = implode("\n", $product_links);
    } else {
        $product_link = '';
    }
    
    if (!empty($Arrproduct_name)) {
        $product_name = implode("\n", $Arrproduct_name);
    } else {
        $product_name = '';
    }
    
    $shipping_add = [
        'firstname' => $order->get_shipping_first_name(),
        'lastname' => $order->get_shipping_last_name(),
        'address1' => $order->get_shipping_address_1(),
        'address2' => $order->get_shipping_address_2(),
        'city' => $order->get_shipping_city(),
        'zipcode' => $order->get_shipping_postcode(),
        'total' => $order->get_total(),
        'state_name' => $order->get_shipping_state(),
        'country' => $order->get_shipping_country(),
    ];

    $data                 = $order->get_data();
    $status               = $order->get_status();
    $version              = $order->get_version();
    $currency             = $order->get_currency();
    $parent_id            = $order->get_parent_id();
    $date_created         = $order->get_date_created();
    $order_comments       = $order->get_customer_note();
    $payment_method       = $order->get_payment_method();
    $id                   = $order->get_transaction_id();
    $payment_method_title = $order->get_payment_method_title();

    $shipping_method      = $order->get_shipping_method();

    $timezone = get_option('timezone_string');
    if (empty($timezone) or $timezone == '') {
        // $timezone="Asia/Jakarta";
    } else {
        date_default_timezone_set($timezone);
    }

    (isset($date_created)) ? $order_date_created = date( 'j F Y, g:i a', $order->get_date_created ()->getOffsetTimestamp()) : $order_date_created = '';

    $date_modified = $order->get_date_modified();
    (isset($date_modified)) ? $timestamp_modified = $date_modified->getTimestamp() : $timestamp_modified = '';
    
    $discount_total = $order->get_discount_total();
    $discount_tax = $order->get_discount_tax();
    $shipping_total = $order->get_shipping_total();
    $shipping_tax = $order->get_shipping_tax();
    $total = $order->get_cart_tax();
    $total_tax = $order->get_total_tax();
    $customer_id = $data['customer_id'];

    //# BILLING INFORMATION:
    $billing_first_name = $order->get_billing_first_name();
    $billing_last_name = $order->get_billing_last_name();
    $billing_company = $order->get_billing_company();
    $billing_address_1 = $order->get_billing_address_1();
    $billing_address_2 = $order->get_billing_address_2();
    $billing_city = $order->get_billing_city();
    $billing_state = $order->get_billing_state();
    $billing_postcode = $order->get_billing_postcode();
    $billing_country = $order->get_billing_country();
    $billing_email = $order->get_billing_email();
    $billing_phone = $order->get_billing_phone();

    $total_bayar  = number_format($shipping_add['total'], wc_get_price_decimals(), wc_get_price_decimal_separator(), wc_get_price_thousand_separator());
    $total_amount = trim($total_bayar);

    //# SHIPPING INFORMATION:
    $shipping_first_name = $order->get_shipping_first_name();
    $shipping_last_name = $order->get_shipping_last_name();
    $shipping_company = $order->get_shipping_company();
    $shipping_address_1 = $order->get_shipping_address_1();
    $shipping_address_2 = $order->get_shipping_address_2();
    $shipping_city = $order->get_shipping_city();
    $shipping_state = $order->get_shipping_state();
    $shipping_postcode = $order->get_shipping_postcode();
    $shipping_country = $order->get_shipping_country();
    $methods = WC()->payment_gateways->payment_gateways();
    $bacs_class = $methods['bacs'];
    $no_rek_all = "\n";

    foreach ($bacs_class->account_details as $k => $v) {
        $count = $k + 1;
        $a = "nama_rek$count";
        $$a = $bacs_class->account_details[$k]['account_name'];
        $b = "nama_bank$count";
        $$b = $bacs_class->account_details[$k]['bank_name'];
        $c = "no_rek$count";
        $$c = $bacs_class->account_details[$k]['account_number'];
        $no_rek_all .= 'Rek : '.$$b.' '.$$c.' a.n : '.$$a."\n\n";

        $a = "account_name$count";
        $$a = $bacs_class->account_details[$k]['account_name'];
        $b = "bank_name$count";
        $$b = $bacs_class->account_details[$k]['bank_name'];
        $c = "account_number$count";
        $$c = $bacs_class->account_details[$k]['account_number'];
    }

    $reminder_diff_template = get_option('woowa_reminder_diff_template');

    if ($tipe == 'reminder_order') {
        $bulk_template = get_post_meta($order_id, 'bulk_template', true);
        if (!empty($bulk_template)) {
            for ($i = 0; $i < 4; ++$i) {
                if ($bulk_template == 0) {
                    $rp_Pesan = get_option('woowa_pesan_reminder_order');

                    if (!empty(get_option('woowa_check_reminder_order'))) {
                        $data_api['file'] = get_option('woowa_pesan_reminder_order_gambar');
                    } else {
                        $data_api['file'] = '';
                    }

                    update_post_meta($order_id, 'bulk_template', '');
                } elseif ($bulk_template == $i) {
                    $rp_Pesan = get_option("woowa_pesan_reminder_order$i");

                    if (!empty(get_option("woowa_check_reminder_order$i"))) {
                        $data_api['file'] = get_option("woowa_pesan_reminder_order_gambar$i");
                    } else {
                        $data_api['file'] = '';
                    }

                    update_post_meta($order_id, 'bulk_template', '');
                }
            }
        } else {
            $set_pesan = get_post_meta($order_id, 'kirim_wa_ke', true);
            // if (empty($reminder_diff_template)) {
            //     $rp_Pesan = get_option('woowa_pesan_reminder_order');
            // } else {
                // for ($i = 1; $i <= 3; ++$i) {
                    if ($set_pesan == 0) {
                        $rp_Pesan = get_option('woowa_pesan_reminder_order');
                        if (!empty(get_option('woowa_check_reminder_order'))) {
                            $data_api['file'] = get_option('woowa_pesan_reminder_order_gambar');
                        } else {
                            $data_api['file'] = '';
                        }
                    // } elseif ($set_pesan == $i) { 
                    } else {
                        $i = $set_pesan;
                        // update_post_meta($order_id, 'kirim_wa_ke', $i);
                        $rp_Pesan = get_option("woowa_pesan_reminder_order$i");
                        if (!empty(get_option("woowa_check_reminder_order$i"))) {
                            $data_api['file'] = get_option("woowa_pesan_reminder_order_gambar$i");
                        } else {
                            $data_api['file'] = '';
                        }
                    }
                // }
            // }
        }
    } else {
        if ($tipe == 'after_checkout') {
            $rp_Pesan = get_option('woowa_pesan');
        } else {
            $rp_Pesan = get_option('woowa_pesan_'.$tipe);
        }
    }

    $customfilename = WOOWA_PATH.'modules/custom_features/custom_features.php';
    if (file_exists($customfilename)) {
        if (get_option('woowa_toggle_order_completed_custom') == 'checked') {
            if ($type == 'order_complete') {
                $json = get_option('woowa_oc_custom_features_data');
                $arrray_customfeatures = json_decode($json);
                
                foreach ($arrray_customfeatures as $key => $value) {
                    if (strtolower($value->title) == strtolower($shipping_method)) {
                        $rp_Pesan = get_option('woowa_pesan_oc_custom_features'.$key);
                    }
                }
            }
        }
    }

    $customfilename = WOOWA_PATH.'modules/custom_features/custom_features.php';
    if (file_exists($customfilename)) {
        if (get_option('woowa_toggle_pending_payment_custom') == 'checked') {
            if ($type == 'pending_payment') {
                $json = get_option('woowa_pp_custom_features_data');
                $arrray_customfeatures = json_decode($json);
                
                foreach ($arrray_customfeatures as $key => $value) {
                    if (strtolower($value->title) == strtolower($payment_method_title)) {
                        $rp_Pesan = get_option('woowa_pesan_pp_custom_features'.$key);
                    }
                }
            }
        }
    }

    $rp_Pesan=str_replace("'","",$rp_Pesan);
    $rp_Pesan=str_replace('"',"",$rp_Pesan);
    $rp_Pesan=str_replace('$',"",$rp_Pesan);

    $checkbox_followup = get_option('woowa_checkbox_followup');
    $time_followup = get_option('woowa_order_completed_followup');
    $followup_type = get_option('woowa_order_completed_followup_type');
    $today = date("Y-m-d");

    if ($tipe == 'order_complete' && $checkbox_followup != '') {
        if ($followup_type == 'day') {
            $send_followup = date('Y-m-d', strtotime($today .'+'. $time_followup.' days'));
            (get_post_meta($order_id, 'follow_up', true)) ? update_post_meta($order_id, 'follow_up', $send_followup) : add_post_meta($order_id, 'follow_up', $send_followup);
            (get_post_meta($order_id, 'follow_up_send', true)) ? NULL : add_post_meta($order_id, 'follow_up_send', 'belum');
        }else {
            $send_followup = date('Y-m-d H:i:s', strtotime($today .'+'. $time_followup.' hours'));
            (get_post_meta($order_id, 'follow_up_send', true)) ? NULL : add_post_meta($order_id, 'follow_up_send', 'belum');
            (get_post_meta($order_id, 'follow_up', true)) ? update_post_meta($order_id, 'follow_up', $send_followup) : add_post_meta($order_id, 'follow_up', $send_followup);
        }
    }

    $site_url = get_site_url();

    $rp_Pesan = str_replace('{', '$', $rp_Pesan);
    $rp_Pesan = str_replace('}', '', $rp_Pesan);
    $pesan_eval = '$isi="'.$rp_Pesan.'";';
    eval($pesan_eval);

    $all_bank_account = $no_rek_all;

    $no_wa_tujuan = woowa_validasi_nomor($billing_phone, $billing_country);

    $data_api['text'] = $isi;
    $data_api['license'] = get_option('woowa_license_number');
    $site_url = str_replace('https://', '', $site_url);
    $site_url = str_replace('http://', '', $site_url);
    $site_url = str_replace('www.', '', $site_url);
    $site_url_arr = explode('/', $site_url);

    if (is_array($site_url_arr)) {
        $site_url = $site_url_arr[0];
    }

    $data_api['domain'] = $site_url;
    $data_api['tipe'] = $tipe;
    $data_api['no_wa_tujuan'] = $no_wa_tujuan;

    if ($tipe != 'reminder_order') {
        if (!empty(get_option("woowa_check_$tipe"))) {
            if (!empty(get_option("woowa_image_$tipe"))) {
                $data_api['file'] = get_option("woowa_image_$tipe"); 
            }
        } else {
            $data_api['file'] = '';
        }
    }

    $bdata = array(
        'kota' => $billing_city,
        'produk' => $product_name,
        'nama_pembeli' => "$billing_first_name $billing_last_name",
        'email' => $billing_email,
        'no_hp' => $billing_phone,
        'provinsi' => $billing_state,
        'negara' => $billing_country,
        'alamat' => "$billing_address_1 $billing_address_2",
        'kodepos' => $billing_postcode,
    );

    $data_api['bdata'] = json_encode($bdata);

    $return['data_api'] = $data_api;
    $return['order_id'] = $order_id;
    $return['isi'] = $isi;
    $return['billing_country'] = $billing_country;
    $return['no_wa_tujuan'] = $no_wa_tujuan;

    return $return;
}

function woowa_sendapi($order_id, $tipe = 'after_checkout'){
    // $folloup = get_post_meta($order_id, 'follow_up_send', TRUE);
    // ($tipe == 'order_complete1') ? $folloup = 'followup_order' : NULL;
    
    $form = woowa_form($order_id, $tipe);
    extract($form);
    $kirim = 'no';
    // ($tipe == 'order_complete1') ? $tipe = 'order_complete' : NULL;
    if (get_option('woowa_checkbox_wa_notif') == 'checked=checked') {
        if (!empty(get_post_meta($order_id, 'woowa_checkbox_notification', true))) {
            if (get_option("woowa_toggle_$tipe") != '') {
                $kirim = 'ok';
            } else {
                // woowa_writelog("#$order_id - $tipe Your Message Failed to Send Because Your Toggle is Turn Off!");
            }
        } else {
            woowa_writelog("#$order_id Your Message Failed to Send Because Your Customer don't want to receive the message!");
        }
    } else {
        if (get_option("woowa_toggle_$tipe") != '') {
            $kirim = 'ok';
        } else {
            // woowa_writelog("#$order_id - $tipe is off : Not send message to $no_wa_tujuan");
        }
    }

    if ($kirim == 'ok') {
        // if ($tipe = 'order_completed1') {
        //     ($folloup == 'followup_order') ? update_post_meta($order_id, 'follow_up_send', 'sudah') : NULL;
        // }
        (get_post_meta($order_id, 'kirim_wa_ke', true)) ? NULL : update_post_meta($order_id, 'kirim_wa_ke', 0);
        (get_post_meta($order_id, 'cs_rotator', true)) ? update_post_meta($order_id, 'cs_rotator', 'belum') : add_post_meta($order_id, 'cs_rotator', 'belum');
        (get_post_meta($order_id, 'terakhir_kirim_wa', true)) ? update_post_meta($order_id, 'terakhir_kirim_wa', date('Y-m-d H:i:s')) : add_post_meta($order_id, 'terakhir_kirim_wa', date('Y-m-d H:i:s'));
        (get_post_meta($order_id, 'reminder_time_terakhir', true)) ? update_post_meta($order_id, 'reminder_time_terakhir', date('Y-m-d H:i:s')) : add_post_meta($order_id, 'reminder_time_terakhir', date('Y-m-d H:i:s'));

		
        if(get_option("woowa_license_type") == "android"){
            woowa_sendapi_cs_rotator($tipe, $order_id);	
        }else {
            woowa_curl_post($data_api, $order_id);
        }
    }
    
    // if (get_option('woowa_toggle_seller_notification_setting') == 'checked') {
    //     woowa_sendapi_seller_notification($order_id, $tipe, $data_api);
    // }
}

function woowa_sendapi_seller_notification($order_id = '', $tipe = 'after_checkout', $dt = '', $id=''){
    if ($tipe == 'order_complete') {
        $tipe2 = 'completed';
    } elseif ($tipe == 'cancel_order') {
        $tipe2 = 'cancelled';
    } elseif ($tipe == 'order_process') {
        $tipe2 = 'processing';
    } elseif ($tipe == 'order_refund') {
        $tipe2 = 'refunded';
    } elseif ($tipe == 'order_failed') {
        $tipe2 = 'failed';
    } elseif ($tipe == 'pending_payment') {
        $tipe2 = 'pending';
    } elseif ($tipe == 'after_checkout') {
        $tipe2 = 'after_checkout';
    } elseif ($tipe == 'on_hold') {
        $tipe2 = 'on_hold';
    }elseif ($tipe == 'reminder_order') {
        $tipe2 = 'reminder_order';
    }

    if ($tipe == 'custom_form') {
        $billing_country = $dt['billing_code'];
        if (get_option('woowa_pesan_cf_seller_notification'.$id) != '') {
            $noseller = get_option('woowa_number_cf_seller_notification'.$id);
            $isi = $dt['isi_seller'];
            woowa_send_api_seller($tipe, $dt, $order_id, $isi, $billing_country, $noseller);
        }
    } else {
        $array_seller = get_option('woowa_seller_service_data');
        $array_seller = json_decode($array_seller, 1);
        foreach ($array_seller as $key => $v) {
            $selected = explode(',', $v['select']);
            $noseller = $v['wa_number'];
            if (in_array($tipe2, $selected)) {  
                $form = woowa_form($order_id, 'seller_notification'.$tipe2);
                extract($form);
                $billing_country = $dt['billing_code'];
                if (get_option('woowa_toggle_seller_notification'.$tipe2) != '') {
                    if (get_option('woowa_toggle_seller_list'.$key) != '') {
                        woowa_send_api_seller($tipe2, $dt, $order_id, $isi, $billing_country, $noseller);
                    }
                }
            }
        }
    }
}

function woowa_send_api_seller($tipe, $data_seller = '', $order_id = '', $isi_seller, $billing_country, $noseller){
    if ($noseller != '') {
        $noseller = woowa_validasi_nomor($noseller, $billing_country);
        if (!empty(get_option('woowa_check_image_seller_notification'.$tipe))) {
            if (!empty(get_option('woowa_image_seller_notification'.$tipe))) {
                $data_seller['file'] = get_option('woowa_image_seller_notification'.$tipe);
            }
        } else {
            $data_seller['file'] = '';
        }

        $data_seller['no_wa_tujuan'] = $noseller;
        $data_seller['text'] = $isi_seller;

        return woowa_curl_post($data_seller, $order_id);
    }
}

function woowa_sendapi_cs_rotator($tipe, $order_id){
    (get_post_meta($order_id, 'kirim_wa_ke', true)) ? NULL : update_post_meta($order_id, 'kirim_wa_ke', 0);
    (get_post_meta($order_id, 'cs_rotator', true)) ? update_post_meta($order_id, 'cs_rotator', 'belum') : add_post_meta($order_id, 'cs_rotator', 'belum');
    (get_post_meta($order_id, 'terakhir_kirim_wa', true)) ? update_post_meta($order_id, 'terakhir_kirim_wa', date('Y-m-d H:i:s')) : add_post_meta($order_id, 'terakhir_kirim_wa', date('Y-m-d H:i:s'));
    (get_post_meta($order_id, 'reminder_time_terakhir', true)) ? update_post_meta($order_id, 'reminder_time_terakhir', date('Y-m-d H:i:s')) : add_post_meta($order_id, 'reminder_time_terakhir', date('Y-m-d H:i:s'));

    (get_post_meta($order_id, 'woowa_apk_order', true)) ? NULL : add_post_meta($order_id, 'woowa_apk_order', 'kosong');

    if ($tipe != 'abandoned_cart') {
        $form = woowa_form($order_id,$tipe);
        extract($form);
    }

    

    $kirim='no';

    if(get_option("woowa_toggle_cs_rotator") != '') {
        $kirim='ok';
    }else {
        // woowa_writelog("#$order_id - $tipe is off : Not send message to $no_wa_tujuan");
    }

    if ($kirim=='ok') {
        $datacs = get_option('woowa_customer_service_data');
        $dt_cs = json_decode($datacs,1);
        $jmlh = count($dt_cs);

        if ( get_option('woowa_current_cs_rotator') != true ) { add_option('woowa_current_cs_rotator',1);}

        if (get_option('woowa_current_cs_rotator') > $jmlh) {
            update_option('woowa_current_cs_rotator', 1);
            woowa_writelog('List CS now start from 1');
        }

        $dt_cs = array_values($dt_cs);
        foreach ($dt_cs as $k_cs => $v_cs){
            $current_cs_rotator = get_option('woowa_current_cs_rotator');
            $cs_id = $k_cs+1;
            $wa_cs = $no_wa_tujuan;
            $player_id = $v_cs['player_id'];

            if ($current_cs_rotator == $cs_id) {
                if (!empty(get_option('woowa_toggle_customer_service'.$current_cs_rotator))){
                    if (get_post_meta($order_id, 'cs_rotator', true) == 'belum' ) {
                        woowa_send_api_cs($data_api, $order_id, $isi, $billing_country, $wa_cs, $player_id, $v_cs['name']);
                        update_post_meta($order_id, 'cs_rotator', 'sudah');
                    }
                }else {
                    $next_cs_rotator = $current_cs_rotator+1;
                    update_option('woowa_current_cs_rotator', $next_cs_rotator);
                    if ($next_cs_rotator > $jmlh) {
                        update_option('woowa_current_cs_rotator', 1);
                        $next_cs_rotator = get_option('woowa_current_cs_rotator');

                        if ($next_cs_rotator == $cs_id){
                            if (!empty(get_option('woowa_toggle_customer_service'.$next_cs_rotator))) {
                                if (get_post_meta($order_id, 'cs_rotator', true) == 'belum' ) {
                                    woowa_send_api_cs($data_api, $order_id, $isi, $billing_country, $wa_cs, $player_id, $v_cs['name']);
                                    update_post_meta($order_id, 'cs_rotator', 'sudah');
                                }
                            }else {
                                $last_cs_rotator = $next_cs_rotator+1;
                                update_option('woowa_current_cs_rotator', $last_cs_rotator);
                            }
                        }
                    }
                }
            }
        }
    }
}

function woowa_send_api_cs($data_api, $order_id, $isi_cs, $billing_country, $nocs, $player_id, $namacs = ''){
    $current_cs_rotator=get_option('woowa_current_cs_rotator');
    $data_cs = $data_api;
    if ($nocs != '') {
        if (!empty(get_option('woowa_check_image_cs_rotator'))) {
            if (!empty(get_option('woowa_image_cs_rotator'))) {
                $data_cs['file'] = get_option('woowa_image_cs_rotator');
            }
        } else {
            $data_cs['file'] = '';
        }
        
        $nocs = woowa_validasi_nomor($nocs, $billing_country);
        $data_cs['no_wa_tujuan'] = $nocs;
        
        $isi_cs;
        $data_cs['text'] = $isi_cs;
        $data_cs['player_id'] = $player_id;
        if (get_post_meta($order_id, 'woowa_apk_order', TRUE) == 'kosong') {
            $next_cs_rotator = $current_cs_rotator+1;
            update_option('woowa_current_cs_rotator', $next_cs_rotator);
            update_post_meta($order_id, 'woowa_apk_order', $player_id);
        }

        return woowa_curl_post($data_cs, $order_id);
    }
}



function woowa_validasi_nomor($billing_phone, $billing_country =''){
    $m=new Main();
    $no_wa_tujuan=$m->phone_validation($billing_phone, $billing_country);
    return $no_wa_tujuan;
}

function woowa_curl_post($data, $order_id = ''){
    if(get_option('woowa_license_type') == 'multivendor') {
        if(get_option('woowa_toggle_wassenger') == 'checked') {
            woowa_send_message_wassenger($data, $order_id);
        }else if(get_option('woowa_toggle_chat_api') == 'checked'){
            woowa_send_message_chatapi($data, $order_id);
        }else if(get_option('woowa_toggle_wa_blas') == 'checked'){
            woowa_send_message_wa_blas($data, $order_id);
        }else if(get_option('woowa_toggle_apiwha') == 'checked'){
            woowa_send_message_apiwha($data, $order_id);
        }else if(get_option('woowa_toggle_waboxapp') == 'checked'){
            woowa_send_message_waboxapp($data, $order_id);
        }else if(get_option('woowa_toggle_wanotif') == 'checked'){
            woowa_send_message_wanotif($data, $order_id);
        }    
    }else if (get_option('woowa_license_type') == 'android') {
        woowa_curl_apk($data, $order_id);
    }else {
        woowa_curl_web($data, $order_id);
    }
}

function woowa_curl_apk($data, $order_id){
    $dataplayer = get_option('woowa_customer_service_data');
    $dataplayer = json_decode($dataplayer, 1);
    
    $judul = str_replace('_', ' ', $data['tipe']);
    $orderID = "ORDER ID - $order_id";
    
    $judul = ucwords($judul);
    $content = array(
        'en' => $orderID
    );

    $text = htmlspecialchars($data['text']);
    $text = str_replace('&', 'n', $text);

    
    ($order_id == 'abandoned_cart') ? $device_id = $data['player_id'] : $device_id = get_post_meta($order_id, 'woowa_apk_order', true);
    
    if ($order_id == 'custom_form' && !empty($data['selected_device'])) {
        $device_id = $data['selected_device'];
    }else {
        $device_id = get_option('woowa_save_default_device');
    }

    foreach ($dataplayer as $key => $value) {
        $playerID = trim($value['player_id']);
        
        if (trim($device_id) == $playerID) {
            $data['no_wa_tujuan']=woowa_validasi_nomor($data['no_wa_tujuan'], '');
            if (get_option('woowa_android_version') == 'version1') {
                $fields = array(
                    'app_id' => OS_APP_ID,
                    'include_player_ids' => ["$playerID"],
                    'data' => array('type' => $judul, 'message' => $text, 'no_wa' => $data['no_wa_tujuan']),
                    // 'large_icon' =>"https://woo-wa.com/wp-content/uploads/2018/12/Woowa-Bulat-Hijau-200px.png",
                    'contents' => $content,
                    'headings' => array(
                        'en' => $judul,
                    ),
                );
                
                $fields = json_encode($fields);
                
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, OS_URL);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8',
                'Authorization: Basic '.OS_AUTH, ));
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    
                $response = curl_exec($ch);
                curl_close($ch);
                woowa_writelog("#".$order_id." Order ID - Send ".$judul." Message to ".$data['no_wa_tujuan']);
            }else {
                $playerID = trim($value['player_id']);
                $param = array(
                    'data' => array(
                        "message"   => $text,
                        //, "schedule" => '2020-05-13 11:21:15',
                        "number"     => $data['no_wa_tujuan']
                    ),
                    'to' => $playerID
                );
                
                $data_json = json_encode($param);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, 'https://fcm.googleapis.com/fcm/send');
                curl_setopt( $ch,CURLOPT_POST, true );
                curl_setopt( $ch,CURLOPT_RETURNTRANSFER, true );
                curl_setopt( $ch,CURLOPT_POSTFIELDS, $data_json);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Content-Type: application/json',
                    'Authorization: Bearer AIzaSyCyXH1aC4rWgMQhaJuQLUTDXfWRBgrCZF4')); //os_auth don't change
                $response = curl_exec($ch);
                curl_close($ch);
                
                woowa_writelog("#".$order_id." Order ID - Send ".$judul." Message to ".$data['no_wa_tujuan']);
            }
        }
    }
}

function woowa_curl_web($data, $order_id){
    $file  = $data['file'];
    $no_wa = $data['no_wa_tujuan'];
    $ip    = get_option('woowa_ip');
    $key   = get_option('woowa_api_key');
    $tipe  = strtoupper($data['tipe']);
    $tipe  = str_replace("_", " ", $tipe);

    $no_wa = str_replace("+","",$no_wa);
    $no_wa = '+'.$no_wa;

    $text = stripslashes($data['text']);
    $text = str_replace("\'", "'", $text);

    $data = array("phone_no" => $no_wa, "message" => $text, "key" => $key);
    $data_string = json_encode($data);
    $url = 'http://116.203.92.59/api/async_send_message';

    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST"); 
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_VERBOSE, 0);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
    curl_setopt($ch, CURLOPT_TIMEOUT, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(
        'Content-Type: application/json',
        'Content-Length: ' . strlen($data_string)) 
    );                                                                                            
    $result = curl_exec($ch);
    curl_close($ch);
    
    woowa_send_image($no_wa, $file);
    woowa_writelog($tipe .' #'. $order_id.' - Send Message to '.$no_wa."( $result )");
}

function woowa_send_image($no_wa, $file){
    $ip = get_option('woowa_ip');
    $key = get_option('woowa_api_key');

    $data = array(
        "phone_no" => $no_wa,
        "key" => $key,
        "url" => $file
    );
    
    $data_string = json_encode($data);
    $url='http://116.203.92.59/api/async_send_image_url';
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST"); 
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_VERBOSE, 0);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
    curl_setopt($ch, CURLOPT_TIMEOUT, 360);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(
        'Content-Type: application/json',
        'Content-Length: ' . strlen($data_string)) 
    ); 
    
    $response = curl_exec($ch);
    $err = curl_error($ch);
    curl_close($ch);

    if ($response == 'image_not_found 404') {
        woowa_writelog('Your image was not found when sending a message to'.$no_wa);
    }

    if ($err) {
        woowa_writelog('Your image is failed send to '.$no_wa);
    }
}

function woowa_api_wa(){
    $data['wa_number'] = $data['no_wa_tujuan'];

    $url = 'http://api.woo-wa.com/v2.0/send-message';
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $result = curl_exec($ch);
    $err = curl_error($ch);
    curl_close($ch);
    if ($err) {
        // echo "cURL Error #:" . $err;
    }
}

function woowa_writelog_dev($n){
    if (DEBUG) {
        $fp = fopen(__DIR__.'/../error/dev.log', 'a');
        fwrite($fp, date('y/m/d h:i:s').' :: '.$n."\n");
        fclose($fp);
    }
}

function woowa_writelog($n){
    $timezone = get_option('timezone_string');
    if (empty($timezone) or $timezone == '') {
        // $timezone="Asia/Jakarta";
    } else {
        date_default_timezone_set($timezone);
    }
    $fp = fopen(__DIR__.'/../error/error.log', 'a');
    $notallow = array('select ', 'insert ', 'replace ', 'order by', 'group by', 'update ', '{', 'http');
    $tulis = 0;
    foreach ($notallow as $k) {
        if (strpos(strtolower($n), 'select') !== false) {
        } else {
            $tulis = 1;
        }
    }
    if ($tulis == 1) {
        if (empty($timezone)) {
            $gmt = get_option('gmt_offset');
            $date = gmdate("d-m-Y H:i:s", time() + 3600*($gmt+date("I")));
            fwrite($fp, $date.' :: '.$n."\n");
        }else {
            fwrite($fp, date('d-m-Y H:i:s').' :: '.$n."\n");
        }
    }
    fclose($fp);
}

function woowa_isJson($string){
    json_decode($string);

    return json_last_error() == JSON_ERROR_NONE;
}

function woowa_prepre($array){
    $result = '<pre>'.print_r($array, 1).'</pre>';

    echo $result;
}

// Adding Meta container admin shop_order pages
add_action( 'add_meta_boxes', 'woowa_add_meta_boxes' );
if ( ! function_exists( 'woowa_add_meta_boxes' ) )
{
    function woowa_add_meta_boxes()
    {
        add_meta_box( 'woowa_meta_data', __('Woowa Additional Info','woocommerce'), 'woowa_data_meta_box', 'shop_order', 'side', 'core' );
    }
}

// Adding Meta field in the meta container admin shop_order pages
if ( ! function_exists( 'woowa_data_meta_box' ) )
{
    function woowa_data_meta_box()
    {
        global $post;

        $meta_field_data = get_post_meta( $post->ID, 'woowa_meta_box_slug', true ) ? get_post_meta( $post->ID, 'woowa_meta_box_slug', true ) : '';

        echo '<input type="hidden" name="woowa_metabox_nonce" value="' . wp_create_nonce() . '">
        <p style="border-bottom:solid 1px #eee;padding-bottom:13px;">
            <textarea type="text" style="width:250px; height:150px;";" name="woowa_field_name">' . $meta_field_data . '</textarea></p>
            <button style="margin-left:200px;" type="submit" class="button button-primary" name="save" value="Save">'.__( 'Save', 'woowa_meta_box_slug' ).'</button>';

    }
}

// Save the data of the Meta field
add_action( 'save_post', 'woowa_save_data_metabox', 10, 1 );
if ( ! function_exists( 'woowa_save_data_metabox' ) )
{

    function woowa_save_data_metabox( $post_id ) {

        // We need to verify this with the proper authorization (security stuff).

        // Check if our nonce is set.
        if ( ! isset( $_POST[ 'woowa_metabox_nonce' ] ) ) {
            return $post_id;
        }
        $nonce = $_REQUEST[ 'woowa_metabox_nonce' ];

        //Verify that the nonce is valid.
        if ( ! wp_verify_nonce( $nonce ) ) {
            return $post_id;
        }

        // If this is an autosave, our form has not been submitted, so we don't want to do anything.
        if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
            return $post_id;
        }

        // Check the user's permissions.
        if ( 'page' == $_POST[ 'post_type' ] ) {

            if ( ! current_user_can( 'edit_page', $post_id ) ) {
                return $post_id;
            }
        } else {

            if ( ! current_user_can( 'edit_post', $post_id ) ) {
                return $post_id;
            }
        }
        // --- Its safe for us to save the data ! --- //

        // Sanitize user input  and update the meta field in the database.
        update_post_meta( $post_id, 'woowa_meta_box_slug', $_POST[ 'woowa_field_name' ] );
    }
}

// Add the field to the product
// add_action('woocommerce_before_add_to_cart_button', 'woowa_custom_product_field');
function woowa_custom_product_field() {
    echo '<div id="woowa_custom_field">
        <label>' . __( 'Woowa Additional Info') . ' </label>
        <input type="text" name="woowa_field_name" value="">
    </div><br>';
}

// Store custom field
add_filter( 'woocommerce_add_cart_item_data', 'save_woowa_custom_product_field', 10, 2 );
function save_woowa_custom_product_field( $cart_item_data, $product_id ) {
    if( isset( $_REQUEST['woowa_field_name'] ) ) {
        $cart_item_data[ 'woowa_field_name' ] = $_REQUEST['woowa_field_name'];
        // below statement make sure every add to cart action as unique line item
        $cart_item_data['unique_key'] = md5( microtime().rand() );
        WC()->session->set( 'woowa_order_data', $_REQUEST['woowa_field_name'] );
    }
    return $cart_item_data;
}

// Add a hidden field with the correct value to the checkout
add_action( 'woocommerce_after_order_notes', 'woowa_custom_checkout_field' );
function woowa_custom_checkout_field( $checkout ) {
    $value = WC()->session->get( 'woowa_order_data' );
    echo '<div id="woowa_custom_checkout_field">
            <input type="hidden" class="input-hidden" name="woowa_field_name" id="woowa_field_name" value="' . $value . '">
    </div>';
}

// Save the order meta with hidden field value
add_action( 'woocommerce_checkout_update_order_meta', 'woowa_custom_checkout_field_update_order_meta' );
function woowa_custom_checkout_field_update_order_meta( $order_id ) {
    if ( ! empty( $_POST['woowa_field_name'] ) ) {
        update_post_meta( $order_id, 'woowa_meta_box_slug', $_POST['woowa_field_name'] );
    }
}

// Display field value on the order edit page (not in custom fields metabox)
add_action( 'woocommerce_admin_order_data_after_billing_address', 'woowa_custom_checkout_field_display_admin_order_meta', 10, 1 );
function woowa_custom_checkout_field_display_admin_order_meta($order){
    $woowa_custom_field = get_post_meta( $order->get_id(), 'woowa_meta_box_slug', true );
    if ( ! empty( $woowa_custom_field ) ) {
        echo '<p><strong>'. __("Woowa Additional Info", "woocommerce").':</strong> ' . get_post_meta( $order->get_id(), 'woowa_meta_box_slug', true ) . '</p>';
    }
}

// Render meta on cart and checkout
add_filter( 'woocommerce_get_item_data', 'woowa_render_meta_on_cart_and_checkout', 10, 2 );
function woowa_render_meta_on_cart_and_checkout( $cart_data, $cart_item = null ) {
    $custom_items = array();
    if( !empty( $cart_data ) ) $custom_items = $cart_data;

    if( isset( $cart_item['woowa_field_name'] ) )
        $custom_items[] = array( "name" => 'Woowa Additional Info', "value" => $cart_item['woowa_field_name'] );

    return $custom_items;
}

// Add the information as meta data so that it can be seen as part of the order
add_action('woocommerce_add_order_item_meta','woowa_add_values_to_order_item_meta', 10, 3 );
function woowa_add_values_to_order_item_meta( $item_id, $cart_item, $cart_item_key ) {
    // lets add the meta data to the order (with a label as key slug)
    if( ! empty( $cart_item['woowa_field_name'] ) )
        wc_add_order_item_meta($item_id, __('Woowa Additional Info label'), $cart_item['woowa_field_name'], true);
}


// add_filter( 'manage_edit-shop_order_columns', 'MY_COLUMNS_FUNCTION' );
// function MY_COLUMNS_FUNCTION( $columns ) {
// 	$new_columns = ( is_array( $columns ) ) ? $columns : array();
//   	unset( $new_columns[ 'order_actions' ] );
	
//   	//edit this for your column(s)
//   	//all of your columns will be added before the actions column
//   	$new_columns['MY_COLUMN_ID_1'] = 'MY_COLUMN_1_TITLE';
//   	$new_columns['MY_COLUMN_ID_2'] = 'MY_COLUMN_2_TITLE';
	
//   	//stop editing
//   	$new_columns[ 'order_actions' ] = $columns[ 'order_actions' ];
//   	return $new_columns;
// }