<?php

function woowa_main_view(){
    $tab_aktif['template']       = '';
    $tab_aktif['integrate']      = '';
    $tab_aktif['statistic']      = '';
    $tab_aktif['error_log']      = '';
    $tab_aktif['abandoned_cart'] = '';
    
    if (!empty($_GET['tab'])) {
        $tab_aktif[$_GET['tab']] = 'active';
    } else {
        if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins'))) || in_array('woocommerce/woocommerce.php', array_keys(get_site_option('active_sitewide_plugins')))){
            $tab_aktif['template'] = 'active';
        }else {
            $tab_aktif['cs_rotator'] = 'active';
        }
    }

    $view = '
    <br>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script src="'.site_url().'/wp-content/plugins/woowa/public/js/bootstrap.min.js"></script>
    <script src="'.site_url().'/wp-content/plugins/woowa/public/js/chart.js"></script>
    <script src="'.site_url().'/wp-content/plugins/woowa/public/js/abandoned.js?v=5.1.5"></script>
    <script src="'.site_url().'/wp-content/plugins/woowa/public/js/bootstrap-toggle.min.js"></script>
    <script type="text/javascript" src="https://cdn.jsdelivr.net/momentjs/latest/moment.min.js"></script>
    <script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js"></script>
    <script type="text/javascript" src="'.site_url().'/wp-content/plugins/woowa/public/js/emojionearea.js"></script>
    
    <script src="'.site_url().'/wp-content/plugins/woowa/public/js/woowa_chatcs.js?v=11111"></script>
	<link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/wa_chatcs.css?v=11111">

    <link rel="stylesheet" type="text/css" href="'.site_url().'/wp-content/plugins/woowa/public/css/emojionearea.css" />
    <link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css" />
    <link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/bootstrap-toggle.min.css">
    <link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/bootstrap.min.css">
    <link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/woowa.css">
    <link href="https://fonts.googleapis.com/css?family=Varela Round" rel="stylesheet">
    <link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/vertical-tab.css">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css" integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
    <style>
        .label-nav{
            display:none;
        }
        .sign{
            transform:rotate(90deg);
            float:left;
            margin-right:10px;
        }
    </style>
    
    <script type="text/javascript">

        function copyToClipboard(element) {
            var $temp = $("<input>");
            $("body").append($temp);
            $temp.val($(element).text()).select();
            document.execCommand("copy");
            $temp.remove();
        }

        jQuery(function(){
            jQuery("#wp-admin-bar-menu-toggle .ab-item").click(function(){
                var cek = jQuery("#wpwrap").hasClass("wp-responsive-open");
                if(cek==true){
                    jQuery("#wpwrap").removeClass("wp-responsive-open");
                }else{
                    jQuery("#wpwrap").addClass("wp-responsive-open");
                }
            });
            
            jQuery(".panel-heading").on("click",function(){
                jQuery(".sign").css("transform","rotate(90deg)");
                if(jQuery(this).next().hasClass("in")){
                    jQuery(this).find("h4 > a > .sign").css("transform","rotate(90deg)");
                }else{
                    jQuery(this).find("h4 > a > .sign").css("transform","rotate(-90deg)");
                }
            });
            jQuery(".nav").find("li").on("click",function(){
                jQuery(".label-nav").hide();
                jQuery(this).find("a").find("span").show();
            });

            jQuery(".wp-has-submenu").hover(
                function() {
                jQuery( this ).addClass("opensub");
                }, function() {
                jQuery( this ).removeClass("opensub");
                }
            );
        });
        '.woowa_cs().'
    </script>
    <div>
        <h2>Notifier for WA '.get_option('woowa_license_type').' <small> Version '.woowa_get_current_version().'</small></h2>
    </div>
    <ul class="nav nav-tabs">';
    
    if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins'))) || in_array('woocommerce/woocommerce.php', array_keys(get_site_option('active_sitewide_plugins')))) {
        $view .= '
        <li class="'.$tab_aktif['template'].'"><a style="font-family: Asap" data-toggle="tab" href="#templatewoowa" id="template_btn"><span class="label-nav" style="display:inline;">Templates</span> <i class="fas fa-scroll"></i> </a></li>
        <li class="'.$tab_aktif['abandoned_cart'].'"><a style="font-family: Asap" data-toggle="tab" href="#abandoned_cart" id="abandoned_cart_btn"><span class="label-nav">Abandoned</span> <i class="fas fa-shopping-cart"></i> </a></li>';
        $show_cf = '';
    } else {
        $show_cf = "style='display:initial;'";
        $tab_aktif['template'] = '';
    }
    
    $view .= '
    </ul>
    <div class="container">
        <div class="tab-content">
            <div id="templatewoowa" class="tab-pane fade in '.$tab_aktif['template'].'">
            '.woowa_templates_view().'
            </div>
            <div id="abandoned_cart" class="tab-pane fade in '.$tab_aktif['abandoned_cart'].'"">
            '.woowa_table_abandoned_cart().'
            </div>
        </div>
    </div>';

    return $view;
}

function woowa_templates_view(){
    $popup                      = woowa_popup_customstatus();
    $toggle_order_failed        = get_option('woowa_toggle_order_failed');
    $toggle_order_refund        = get_option('woowa_toggle_order_refund');
    $toggle_cancel_order        = get_option('woowa_toggle_cancel_order');
    $toggle_order_process       = get_option('woowa_toggle_order_process');
    $toggle_abandoned_cart      = get_option('woowa_toggle_abandoned_cart');
    $toggle_reminder_order      = get_option('woowa_toggle_reminder_order');
    $toggle_order_complete      = get_option('woowa_toggle_order_complete');
    $toggle_after_checkout      = get_option('woowa_toggle_after_checkout');
    $toggle_pending_payment     = get_option('woowa_toggle_pending_payment');
    $toggle_seller_notification = get_option('woowa_toggle_seller_notification');

    if (get_option('woowa_license') != 'active') {
        return '<br>please activate license code. click <a href="'.site_url().'/wp-admin/admin.php?page=notifierwa-main-menu&tab=license"  aria-expanded="true">here</a>';
    }
    $html = '
    <br>
    <br>
    <h3>Customer Notification Templates</h3>
    <div class="bs-example">
        <div class="panel-group" id="accordion">
            <div class="panel panel-default ">
                <div class="panel-heading">
                    <h4 class="panel-title">
                        <a data-toggle="collapse" data-parent="#accordion" href="#after_checkout_accordion" onclick="" style="display:block;" ><div class="sign">&#187;</div>After Checkout</a>
                        <div class="on_off_container">
                            <input type="checkbox" '.$toggle_after_checkout.' data-size="mini" data-toggle="toggle" name="onoff_after_checkout" id="onoff_after_checkout" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">
                        </div>
                    </h4>
                </div>
                <div id="after_checkout_accordion" class="panel-collapse collapse ">
                    <div class="panel-body">
                    '.woowa_after_checkout_view().'
                    </div>
                </div>
            </div>
            <div class="panel panel-default"> 
                <div class="panel-heading">
                    <h4 class="panel-title">
                    <a data-toggle="collapse" data-parent="#accordion" href="#order_complete_accordion" value="dinamic"  style="display:block;" ><div class="sign">&#187;</div>Order Complete</a>
                    <div class="on_off_container">
                    <input type="checkbox" '.$toggle_order_complete.' data-size="mini" data-toggle="toggle" name="onoff_order_complete" id="onoff_order_complete" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">        
                    </div>
                    </h4>
                </div>
                <div id="order_complete_accordion" class="panel-collapse collapse ">
                    <div class="panel-body">
                    '.woowa_order_complete_view().'
                    </div>
                </div>
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="panel-title">
                    <a data-toggle="collapse" data-parent="#accordion" href="#reminder_order_accordion" value="dinamic" style="display:block;" ><div class="sign">&#187;</div>Reminder Order</a>
                    <div class="on_off_container">
                    <input type="checkbox" '.$toggle_reminder_order.' data-size="mini" data-toggle="toggle" name="onoff_reminder_order" id="onoff_reminder_order" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">
                    </div>
                    </h4>
                </div>
                <div id="reminder_order_accordion" class="panel-collapse collapse ">
                    <div class="panel-body">
                    '.woowa_reminder_order_view().'
                    </div>
                </div>
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="panel-title">
                    <a data-toggle="collapse" data-parent="#accordion" href="#cancel_order_accordion" value="dinamic" style="display:block;" ><div class="sign">&#187;</div>Cancel Order</a>
                    <div class="on_off_container">
                    <input type="checkbox" '.$toggle_cancel_order.' data-size="mini" data-toggle="toggle" name="onoff_cancel_order" id="onoff_cancel_order" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">
                    </div>
                    </h4>
                </div>
                <div id="cancel_order_accordion" class="panel-collapse collapse ">
                    <div class="panel-body">
                    '.woowa_cancel_order_view().'
                    </div>
                </div>
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="panel-title">
                    <a data-toggle="collapse" data-parent="#accordion" href="#order_process_accordion" value="dinamic"  style="display:block;" ><div class="sign">&#187;</div>Order Processing</a>
                    <div class="on_off_container">
                    <input type="checkbox" '.$toggle_order_process.' data-size="mini" data-toggle="toggle" name="onoff_order_process" id="onoff_order_process" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">        
                    </div>
                    </h4>
                </div>
                <div id="order_process_accordion" class="panel-collapse collapse ">
                    <div class="panel-body">
                    '.woowa_order_process_view().'
                    </div>
                </div>
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="panel-title">
                    <a data-toggle="collapse" data-parent="#accordion" href="#order_refund_accordion" value="dinamic"  style="display:block;" ><div class="sign">&#187;</div>Order Refunded</a>
                    <div class="on_off_container">
                    <input type="checkbox" '.$toggle_order_refund.' data-size="mini" data-toggle="toggle" name="onoff_order_refund" id="onoff_order_refund" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">        
                    </div>
                    </h4>
                </div>
                <div id="order_refund_accordion" class="panel-collapse collapse ">
                    <div class="panel-body">
                    '.woowa_order_refund_view().'
                    </div>
                </div>
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="panel-title">
                    <a data-toggle="collapse" data-parent="#accordion" href="#order_failed_accordion" value="dinamic"  style="display:block;" ><div class="sign">&#187;</div>Order Failed</a>
                    <div class="on_off_container">
                    <input type="checkbox" '.$toggle_order_failed.' data-size="mini" data-toggle="toggle" name="onoff_order_failed" id="onoff_order_failed" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">        
                    </div>
                    </h4>
                </div>
                <div id="order_failed_accordion" class="panel-collapse collapse ">
                    <div class="panel-body">
                    '.woowa_order_failed_view().'
                    </div>
                </div>
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="panel-title">
                    <a data-toggle="collapse" data-parent="#accordion" href="#pending_payment_accordion" value="dinamic"  style="display:block;" ><div class="sign">&#187;</div>Pending Payment</a>
                    <div class="on_off_container">
                    <input type="checkbox" '.$toggle_pending_payment.' data-size="mini" data-toggle="toggle" name="onoff_pending_payment" id="onoff_pending_payment" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">        
                    </div>
                    </h4>
                </div>
                <div id="pending_payment_accordion" class="panel-collapse collapse ">
                    <div class="panel-body">
                    '.woowa_pending_payment_view().'
                    </div>
                </div>
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="panel-title">
                    <a data-toggle="collapse" data-parent="#accordion" href="#abandoned_cart_accordion" value="dinamic"  style="display:block;" ><div class="sign">&#187;</div>Abandoned Cart</a>
                    <div class="on_off_container">
                    <input type="checkbox" '.$toggle_abandoned_cart.' data-size="mini" data-toggle="toggle" name="onoff_abandoned_cart" id="onoff_abandoned_cart" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">        
                    </div>
                    </h4>
                </div>
                <div id="abandoned_cart_accordion" class="panel-collapse collapse ">
                    <div class="panel-body">
                    '.woowa_abandoned_cart_view().'
                    </div>
                </div>
            </div>
            <div>
                <h3 style="display: inline-block;">Custom Order Status Templates </h3>&nbsp<button type="button" class="btn btn-xs btn-primary" data-target="#tooltipcustomstatus" style="margin-bottom:13px" data-toggle="modal"><i class="fas fa-question"></i></button>
                '.woowa_custom_status_accordion().'
            </div>
            <div>
                <h3>Seller List</h3>
                '.woowa_get_allstatus_template().'
            </div>
        </div>
    </div>';

    return $html.$popup;
}

function woowa_popup_customstatus(){
    $view = 
   '<div class="modal fade" id="tooltipcustomstatus" tabindex="-1" role="dialog" aria-labelledby="tooltipcustomstatusLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="tooltipcustomstatusLabel">You need one of those additional plugin to use this feature</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <img src="'.site_url().'/wp-content/plugins/woowa/public/img/custom-status-plugins.jpg" style="display: block; margin-left: auto; margin-right: auto; width: 50%;"><br><br>
                    <a type="button" class="btn btn-success" data-dismiss="modal" onclick="window.open(\'https://woocommerce.com/products/woocommerce-order-status-manager/\',\'_blank\')">Click here to get your woocommerce order status manager</a><br><br>
                    <a type="button" class="btn btn-success" data-dismiss="modal" onclick="window.open(\'https://yithemes.com/themes/plugins/yith-woocommerce-custom-order-status/\',\'_blank\')">Click here to get your YITH woocommerce order status manager</a><br><br>
                    <a type="button" class="btn btn-success" data-dismiss="modal" onclick="window.open(\'https://wordpress.org/plugins/custom-order-statuses-woocommerce/\',\'_blank\')">Click here to get your custom order statuses </a>
                </div>
            </div>
        </div>
   </div>';

   return $view;
}