<?php

function woowa_token_view(){
    $popup = pop_up_token();
    $view = '';
    if (get_option('woowa_license')!='active') { return ('<br>please activate license code. click <a href="#license"  data-toggle="tab" aria-expanded="true">here</a>');}
        $toggle_token = get_option('woowa_toggle_token');
        if ($toggle_token != 'checked') {
            $hide='style="display:none;"';
        }else{
            $hide='';
        }
        $script = woowa_script_token_view();
        $view.='
        <br><br>
        
        <div id="btn_toggle_token">
            <span style="float:right;">
                <input type="checkbox" '.$toggle_token.'  data-toggle="toggle" name="onoff_token" id="onoff_token" data-off="OFF" data-on="ON" data-onstyle="success"  data-offstyle="danger">
            </span>
            <span style="float:right;"></span>
        </div>';
        $datatoken = get_option('woowa_token_data');
        $datatoken = json_decode($datatoken, 1);

      $view.='<br>
        <br style="clear:both;">
        <br>
        <form method="post" id="form_token" '. $hide .'>
        <button class="btn btn-xs btn-success" style="margin-left:10px; margin-bottom:2px;" onclick=jQuery("#token-name").val(""); onclick=jQuery("#token-number").val(""); data-toggle="modal" data-target="#token_number" type="button"><i class="fas fa-cog"></i> Add key</button>&nbsp<button class="btn btn-xs btn-primary" type="button" style="margin-bottom:2px;" data-toggle="modal" data-target="#tooltip_key"><i class="fas fa-question"></i></button> 
        <div>
        <table class="table" style="border:none;">
            <thead>
            <tr>
                <th scope="col">Nama</th>
                <th scope="col">Key</th>';
                $view.='<th scope="col">Action</th>
            </tr>
            </thead>
            <tbody class="tbody-token">';

        $array_token = get_option('woowa_token_data');
        $array_token = json_decode($array_token,1);
        if (!empty($array_token)) {
            if (!empty(get_option('woowa_token_data'))) {
                foreach ($array_token as $key => $value) {
                    // echo $key;
                    $id = $key;
                    $name = $value['name'];
                    $token = $value['token'];
                    $toggle_token = get_option('woowa_toggle_token'.$id);
                    $view .= '
                    <tr id="token_'.$id.'">
                      <td class="token_name">
                      '.$name.'
                      </td>
                      <td class="token_number">
                      <span>'.$token.'</span>
                    </td>';
                      $view.='
                      <td data-token-id="'.$id.'">
                      <button class="btn btn-xs btn-primary" type="button" style="margin-left:10px; margin-bottom:2px;" data-toggle="modal" data-target="#update_token'.$id.'"><i class="fas fa-pencil-alt"></i></button>
                      <button class="btn btn-xs btn-danger" type="button" style="margin-left:10px; margin-bottom:2px; margin-right:10px;" data-toggle="modal" data-target="#delete_token'.$id.'"><i class="far fa-trash-alt"></i></button>
                      <input type="checkbox" '.$toggle_token.' id="toggle_token'.$id.'" data-toggle="toggle" data-size="mini" class="toggle-token">
                      </td>
                    </tr>'.
                    pop_up_token($id, $name, $token).'';
                }
            }
        }
        
            $view.='
            </tbody>
        </table>
        <div id="notif_token"></div>
        </div>
        </form>
        <br><br>';
    
    return $view.$script.$popup;
}


function pop_up_token($id='', $name='',$token=''){
  $view = '
    <div class="modal fade" id="token_number" tabindex="-1" role="dialog" aria-labelledby="token_numberLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                <h5 class="modal-title" id="token_numberLabel">Please set your key</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                </div>
                <div class="modal-body">
                <form>
                    <div class="form-group">
                    <label for="token-name" class="col-form-label">Name:</label>
                    <input type="text" class="form-control" id="token-name-'.$id.'">
                    <label for="token-number" class="col-form-label">Key:</label>
                    <input type="text" class="form-control" id="token-number-'.$id.'">';
            $view.='</div>
                </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-primary" onclick="return ajax_add_token('.$id.');" data-dismiss="modal">Add</button>
                </div>
            </div>
        </div>
    </div>';

  $view.=
  '<div class="modal fade" id="update_token'.$id.'" tabindex="-1" role="dialog" aria-labelledby="update_tokenLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="update_tokenLabel">Update Key</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
        <form>
          <div class="form-group">
            <label for="token-name" class="col-form-label">Name :</label>
            <input type="text" class="form-control" id="token-name'.$id.'" value="'.$name.'">
            <label for="token-number" class="col-form-label">Key :</label>
            <input type="text" class="form-control" id="token-number'.$id.'" value="'.$token.'">
          </div>
        </form>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
          <button type="button" class="btn btn-success"  data-dismiss="modal" onclick="return ajax_update_token('.$id.');">Save</button>
        </div>
      </div>
    </div>
  </div>';

  $view .= 
  '<div class="modal fade" id="delete_token'.$id.'" tabindex="-1" role="dialog" aria-labelledby="delete_tokenLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="delete_tokenLabel">Delete key</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <form>
            <div class="form-group">
              Are You Sure Delete This key?
            </div>
          </form>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
          <button type="button" class="btn btn-success"  data-dismiss="modal" onclick="return ajax_delete_token('.$id.')">Yes</button>
        </div>
      </div>
    </div>
  </div>';

  $view .= 
  '<div class="modal fade" id="tooltip_key" tabindex="-1" role="dialog" aria-labelledby="tooltip_keyLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="tooltip_keyLabel">Where is your key? Here!</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <img src="'.site_url().'/wp-content/plugins/woowa/public/img/how-to-get-key.jpg">
        </div>
        <div class="modal-body">
          <a type="button" class="btn btn-success" data-dismiss="modal" onclick="window.open(\'https://app.woo-wa.com\',\'_blank\')">Click here to get your key</a>
        </div>
      </div>
    </div>
  </div>';

  return $view;
}