<?php 

function woowa_settings_main_view(){
	$tab_aktif['setting']='';
	$tab_aktif['license'] = '';
	$tab_aktif['integrate'] = '';
	$tab_aktif['error_log'] = '';
	$tab_aktif['cs_rotator'] = '';
	$tab_aktif['whatsapp_rotation'] = '';
	
	if (!empty($_GET['tab'])) {
		$tab_aktif[$_GET['tab']]="active";
	}else if(get_option("woowa_license_type") == "multivendor"){
		$tab_aktif['integrate']='active';
	}else if (get_option("woowa_license_type") == "android"){
		$tab_aktif['cs_rotator'] = 'active';
	}else {
		$tab_aktif['setting']='active';
	}

	if ( get_option('woowa_license') == 'active') {
		$logo = '<i class="fas fa-lock-open"></i>';
	}else {
		$logo = '<i class="fas fa-lock"></i>';
	}
	
	$view = '
	<br>
	
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
	<script src="'.site_url().'/wp-content/plugins/woowa/public/js/bootstrap.min.js"></script>
	<script src="'.site_url().'/wp-content/plugins/woowa/public/js/chart.js"></script>    
	<script src="'.site_url().'/wp-content/plugins/woowa/public/js/bootstrap-toggle.min.js"></script>
	<script type="text/javascript" src="https://cdn.jsdelivr.net/momentjs/latest/moment.min.js"></script>
	<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js"></script>
	<script type="text/javascript" src="'.plugins_url("woowa/public/js/intlTelInput.js").'"></script>

	<script src="'.site_url().'/wp-content/plugins/woowa/public/js/woowa_chatcs.js?v=11111"></script>
	<link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/wa_chatcs.css?v=11111">

	
	<link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css" />
	<link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/bootstrap-toggle.min.css">
	<link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/bootstrap.min.css">
	<link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/woowa.css">
	<link href="https://fonts.googleapis.com/css?family=Varela Round" rel="stylesheet">
	<link rel="stylesheet" href="'.site_url().'/wp-content/plugins/woowa/public/css/vertical-tab.css">
	<link rel="stylesheet" href="'.plugins_url("woowa/public/css/intlTelInput.css").'">
	<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css" integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
	<style>
		.label-nav{
		display:none;
		}
	</style>
	<script type="text/javascript">
		jQuery(function(){
		jQuery(".nav").find("li").on("click",function(){
			jQuery(".label-nav").hide();
			jQuery(this).find("a").find("span").show();
		});

		jQuery(".wp-has-submenu").hover(
			function() {
			jQuery( this ).addClass("opensub");
			}, function() {
			jQuery( this ).removeClass("opensub");
			}
		);
		});
		
		
	</script>
	<div>
		<h2>Notifier for WA '.get_option('woowa_license_type').'<small> Version '.woowa_get_current_version().'</small>
		<!--<span style="float:right">
			<h5>Join our group</h5><a href="https://www.facebook.com/groups/wpwoowa/" target="__blank"><i class="fab fa-facebook-f"></i></a></span>-->
		</h2>

		'.woowa_cs().'
	</div>
	
	<ul class="nav nav-tabs">';
	
		if (get_option('woowa_license_type') == 'android') {
			$view .= '<li class="'.$tab_aktif['cs_rotator'].'"><a style="font-family: Asap" data-toggle="tab" href="#cs_rotator" id="cs_rotator_btn"><span class="label-nav">List CS</span> <i class="fas fa-phone"></i> </a></li>';
		}
		if (get_option('woowa_license_type') == 'multivendor') {
			$view.='<li class="'.$tab_aktif['integrate'].'"><a style="font-family: Asap" data-toggle="tab" href="#integrate_tab" id="integrate_btn"><span class="label-nav" style="display:inline;">Integrate</span> <i class="fas fa-tools"></i></a></li>';
		}
		
		if (get_option('woowa_license_type') != 'android') {
			$view.='<li class="'.$tab_aktif['whatsapp_rotation'].'"><a style="font-family: Asap" data-toggle="tab" href="#whatsapp_rotation" id="whatsapp_rotation_btn"><span class="label-nav">Whatsapp rotation</span> <i class="fab fa-whatsapp fa-lg"></i> </a></li>';
		}

		$view.='<li class="'.$tab_aktif['setting'].'"><a style="font-family: Asap" data-toggle="tab" href="#setting_tab" id="setting_btn"><span class="label-nav">Setting</span> <i class="fas fa-wrench"></i> </a></li>
			<li class="'.$tab_aktif['license'].'"><a style="font-family: Asap" data-toggle="tab" href="#license" id="license_btn"><span class="label-nav">License</span> '.$logo.' </a></li>';
		$view .= '<li class="'.$tab_aktif['error_log'].'"><a style="font-family: Asap" data-toggle="tab" href="#error_log" id="error_btn"><span class="label-nav">Log</span> <i class="fas fa-exclamation-triangle"></i> </a></li>';

		$view.='
	</ul>
	
	<div class="container">
		<div class="tab-content">';

		if (get_option('woowa_license_type') == 'android') {
			$view .=
				'<div id="cs_rotator" class="tab-pane fade in '.$tab_aktif['cs_rotator'].'"">
					'.woowa_cs_rotator_view().'
				</div>';
		}

		if (get_option('woowa_license_type') == 'multivendor') {
			$view.=
			'<div id="integrate_tab" class="tab-pane fade in '.$tab_aktif['integrate'].'">
				'.woowa_integrate_main_view().'
			</div>';
		}
		
		if (get_option('woowa_license_type') != 'android') {
			$whatsapp_rotation_view=
			'<div id="whatsapp_rotation" class="tab-pane fade in '.$tab_aktif['whatsapp_rotation'].'">
				'.woowa_token_view().'
			</div>';
		}else {
			$whatsapp_rotation_view= '';
		}

	$view.='<div id="setting_tab" class="tab-pane fade in '.$tab_aktif['setting'].'">
				'.woowa_setting_view().'
			</div>
			'.$whatsapp_rotation_view.'
			<div id="license" class="tab-pane fade in '.$tab_aktif['license'].'">
				'.woowa_license_view().'
			</div>
			<div id="error_log" class="tab-pane fade in '.$tab_aktif['error_log'].'">
            	'.woowa_error_log_view().'
            </div>
		</div>
	</div>
	';

	echo $view;
}

function woowa_cs(){
	$view = 
	'
	<div class="woowa_btn_popup">
		<div class="woowa_btn_popup_icon"></div>
	</div>
	<div class="woowa_popup_chat_box">
		<div class="woowa_popup_heading">
			<div class="woowa_popup_title">
				Woowa Costumer Service
			</div>
		</div>
		<div class="woowa_popup_content woowa_popup_content_left">
			<div class="woowa_popup_content_list">
				<div class="woowa_popup_content_item">
					<a class="woowa_stt woowa_stt_online" href="https://api.whatsapp.com/send?phone=6289675180205" target="_blank">
					<div class="woowa_popup_avatar">
						<div class="woowa_cs_img_wrap" style="background: url(https://library.kissclipart.com/20181005/bee/kissclipart-white-person-icon-png-clipart-computer-icons-deskt-73f851694f2ebca8.jpg) center center no-repeat; background-size: cover;"></div>
					</div>
					<div class="woowa_popup_txt">
						<div class="woowa_cs_name">
							Jazuli
						</div>
						<div class="woowa_cs_duty">
							Customer Service
						</div>
						<div class="woowa_cs_status">
							<font color="green">Online</font>
						</div>
					</div>
					</a>
				</div>
					<div class="woowa_popup_content_item">							
					<a class="woowa_stt woowa_stt_online" href="https://api.whatsapp.com/send?phone=6289675180205" target="_blank">
					<div class="woowa_popup_avatar">
						<div class="woowa_cs_img_wrap" style="background: url(https://library.kissclipart.com/20181005/bee/kissclipart-white-person-icon-png-clipart-computer-icons-deskt-73f851694f2ebca8.jpg) center center no-repeat; background-size: cover;"></div>
					</div>
					<div class="woowa_popup_txt">
						<div class="woowa_cs_name">
							Jazuli 2
						</div>
						<div class="woowa_cs_duty">
							Costumer Service 2
						</div>
						<div class="woowa_cs_status">
							<font color="green">Online</font>
						</div>
					</div>
					</a>
				</div>
			</div>
		</div>
	</div>';
}

function woowa_setting_view(){
	$version=trim(woowa_get_current_version());
	$script = woowa_script_setting_view($version);
	woowa_get_downgrade();
	$onhold_alias = get_option('woowa_onhold_alias');
	$checkbox = get_option('woowa_checkbox_wa_notif');
	$checkbox_text = get_option('woowa_checkbox_wa_text');

	if (get_option('woowa_checkbox_customer_note_sendwa') == 'false') {
		$customer_note_checked="checked";
	}else{
		$customer_note_checked="";
	}
	$radio1=$radio2='';
	if (get_option('woowa_android_version') == 'version1') {
		$radio1 = 'checked';
	}else {
		$radio2 = 'checked';
	}
	
	if (get_option('woowa_license')!='active') { return ('<br>please activate license code. click <a href="#license" data-toggle="tab" aria-expanded="true">here</a>');}
    if ( get_option('woowa_default_country_code') == false ) {
	  $deprecated = null;
	  $autoload = 'no';
	  add_option( 'woowa_default_country_code', '', $deprecated, $autoload );
	}

	$default_country="id";
	if(get_option('woowa_default_country_code_huruf')!==false and get_option('woowa_default_country_code_huruf')!=''){
		$default_country=get_option('woowa_default_country_code_huruf');
	}
    $view=
    '<style>
    	#loading_cek_update,#status_version{
    		display:none;
    	}
    </style>
    <script type="text/javascript">jQuery(function(){
      jQuery(".country_code").intlTelInput({
      	preferredCountries: ["'.$default_country.'","id"],
      });
      	jQuery(".country_code").on("blur",function(){
      		var b=jQuery(".selected-flag .flag").attr("class");
      		var arr=b.split(" ");
      		var huruf_country=arr[1];
      		jQuery("input[name=default_country_code_huruf]").val(huruf_country);
      	});
      	jQuery("li.country").on("click",function(){
      		var a=jQuery(this).attr("data-country-code"); 
      		jQuery("input[name=default_country_code_huruf]").val(a);
      	})

    });</script>';
    $active_sitewide_plugins=array();
	if (get_site_option('active_sitewide_plugins')!==false) {
		$active_sitewide_plugins=get_site_option('active_sitewide_plugins');
	}

	if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins'))) || in_array('woocommerce/woocommerce.php', array_keys($active_sitewide_plugins))){
      	$hide_woowa="";
	}else{
		$hide_woowa="style='display:none;'";
	}

	if (get_option('woowa_checkbox_wa_notif') == 'checked=checked') {
        $show_hide_checked_checbox='';
	}else {
        $show_hide_checked_checbox='style="display:none;"';
	}
	
	$checked_by_default = get_option('woowa_checkbox_checked_confirmation');
    
    $view.='
    <div style="float:left;">
	    <h3>Setting : </h3>
	    <form method="post" id="form_setting">
	    	<input type="hidden" name="action" value="save_setting">
	    	Default Phone Country Code <input type="text" class="country_code" name="default_country_code" value="" style="width:120px;margin-bottom:10px;" maxlength="5" />
	    	<input type="hidden" name="default_country_code_huruf" value="'.get_option('woowa_default_country_code_huruf').'" style="width:60px;margin-bottom:10px;" /><br>
	    	<div id="checkbox_setting" '.$hide_woowa.'>
				<input type="checkbox" value="check" class="cbx" name="checkbox_wa" id="checkbox_wa_notif" '. $checkbox .' style="margin: 0px;" onclick="return check_default_confirmation(this);"> <span style="color: gray;">Add Checkbox Confirmation about <br>&nbsp;&nbsp; &nbsp; sending WA notifications on your Checkout Page </span><button type="button" class="btn btn-xs btn-primary" data-toggle="modal" onclick="getdata()" data-target="#checkboxconfirmation"><i class="fas fa-question"></i></button>
				<div id="check_default_confirmation" '.$show_hide_checked_checbox.'>
				  <input type="checkbox" value="check" name="checked_by_default" '.$checked_by_default.' class="cbx" > <span style="color: gray;" >The Confirmation check box will be checked by default</span>
				</div>

			    <div style="margin-top:10px;"> 
			    	<span style="color: gray;">Custom Checkbox Text on Your Checkout Page :</span><br>
					<input type="text" name="checkbox_wa_text" style="width: 400px;" value="'.$checkbox_text.'">
					<br> <br> 
					<input type="checkbox" id="note" name="checkbox_customer_note_sendwa" '.$customer_note_checked.' value="on"/> <label for="note" style="margin: 2px 0 0 4px;"> Send WA for woocommerce customer notes</label>
				</div>';
				if (get_option('woowa_license_type') == 'android') {
					$view .=
					'<div style="margin-top:15px">
						Choose Woowa Android version you use.
						<div class="custom-control custom-radio" style="margin-top:10px">
							<input type="radio" id="woowaandroidv1" name="woowaandroidversion" class="custom-control-input" value="version1" '.$radio1.'>
							<label class="custom-control-label" for="woowaandroidv1">Woowa Android V1</label>
						</div>
						<div class="custom-control custom-radio">
							<input type="radio" id="woowaandroidv2" name="woowaandroidversion" class="custom-control-input" value="version2" '.$radio2.'>
							<label class="custom-control-label" for="woowaandroidv2">Woowa Android V2</label>
						</div>
					</div>';
				}
	$view.=
		'</div>
		    <br><br>
			<input type="button" value=" Save Setting " onclick="return ajax_setting();" class="btn btn-success"><br>
			<div id="saved_effect"></div>
	  	</form>
	</div>
    <div style="float:right;">
		<h3>Updates : </h3>
		<div id="setting_notif"></div><br>
			<input type="button" value=" Check UPDATE " onclick="return ajax_cek_update();" class="btn btn-success" data-toggle="modal" data-target="#exampleModalCenter">
			<input type="button" value=" DOWNGRADE " onclick="return ajax_cek_downgrade(\''.trim($version).'\');" class="btn btn-danger" data-toggle="modal" data-target="#exampleModalCenter">	
		<div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
			<div class="modal-dialog" role="document">
				<div class="modal-content" style="margin-top: 200px;">
					<div class="modal-header">
						<h5 class="modal-title" id="exampleModalLongTitle" style="float:left;font-weight:bold;">Downgrade Version</h5>
						<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
						</button>
					</div>
					<div class="modal-body">

					</div>
				</div>
			</div>
		</div>
	</div>


	<div class="modal fade" id="checkboxconfirmation" tabindex="-1" role="dialog" aria-labelledby="checkboxconfirmationLabel" aria-hidden="true">
	<div class="modal-dialog modal-lg" role="document">
		<div class="modal-content">
		<div class="modal-header">
			<h5 class="modal-title" id="checkboxconfirmationLabel">Checkbox confirmation</h5>
			<button type="button" class="close" data-dismiss="modal" aria-label="Close">
			<span aria-hidden="true">&times;</span>
			</button>
		</div>
		<div class="modal-body">
			<img src="'.site_url().'/wp-content/plugins/woowa/public/img/checbox-confirmation.jpg">
		</div>
		</div>
	</div>
	</div>
    ';
    return $view.$script;
}
