<?php  
/** 
* Plugin Name: Notifier to Whatsapp
* Plugin URI: https://qodrbee.com/notifierwa
* Description: Tool for connect Woocommerce with Whatsapp Notifier
* Version: 0.3.9
* Author: QODR
* Author URI: https://qodrbee.com 
* License: GPL-2.0+   
* License URI: http://www.gnu.org/licenses/gpl-2.0.txt 
* 27-01-2020
*/ 
 

if ( ! defined( 'WPINC' ) ) { 
     die('..'); 
}

include_once("config/inc.php");

function woowa_premium_helper_menu(){ 
	add_menu_page(
		__( 'Notifier for WA', 'Notifier for WA' ),
		'Notifier for WA',
        'manage_options',
        'notifierwa-main-menu',
        'woowa_main',
        WOOWA_URI.'public/img/logo_woowa_1.png',
        54
	);

	$active_sitewide_plugins=array();
	if (get_site_option('active_sitewide_plugins')!==false) {
		$active_sitewide_plugins=get_site_option('active_sitewide_plugins');
	}

	if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins'))) || in_array('woocommerce/woocommerce.php', array_keys($active_sitewide_plugins))) {
		add_submenu_page('notifierwa-main-menu', 'Template for Woocommerce', 'Template for Woocommerce', 'manage_options', 'notifierwa-woocommerce', 'woowa_woocommerce');
	}

	add_submenu_page('notifierwa-main-menu', 'Custom Form', 'Custom Form', 'manage_options', 'notifierwa-customform', 'woowa_custom_form');

	$customfilename = WOOWA_PATH.'modules/custom_features/custom_features.php';
	if (file_exists($customfilename)) {
		// add_submenu_page('notifierwa-main-menu', 'Custom Features', 'Custom Features', 'manage_options', 'notifierwa-custom-features', 'woowa_custom_features');
	}
}

function woowa_active_plugin() {


}

function woowa_deactive_plugin() {


}